<?php
/**
 * 2019 Addify
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    Addify
 *  @copyright 2019 Addify
 *  @license   http://opensource.org/licenses/afl-3.0.php
 */

if (!defined('_PS_VERSION_')) {
    exit;
}
include_once(_PS_MODULE_DIR_).'addifypasswordprotected/classes/Passwordprotected.php';
include_once(_PS_MODULE_DIR_).'addifypasswordprotected/classes/Passwordprotectedaccesslog.php';
class Addifypasswordprotected extends Module
{
    protected $config_form = false;
    public $templateFile = 'passwordprotected_v6.tpl';

    public function __construct()
    {
        $this->name = 'addifypasswordprotected';
        $this->tab = 'front_office_features';
        $this->version = '1.4.0';
        $this->author = 'Addify';
        $this->need_instance = 0;
        $this->module_key = '99cf39e11aa264f2c9f11ae13bd9b91f';

        /**
         * Set $this->bootstrap to true if your module is compliant with bootstrap (PrestaShop 1.6)
         */
        $this->bootstrap = true;

        parent::__construct();

        $this->displayName = $this->l('Addify Password Protected');
        $this->description = $this->l('Password Protected Categories,Product and CMS pages');

        $this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_);
        if (true === Tools::version_compare(_PS_VERSION_, '1.7.0.0', '>=')) {
            $this->templateFile = 'module:'.$this->name.'/views/templates/front/passwordprotected_v7.tpl';
        }
    }

    /**
     * Don't forget to create update methods if needed:
     * http://doc.prestashop.com/display/PS16/Enabling+the+Auto-Update
     */
    public function install()
    {

        Configuration::updateValue('addifypasswordprotected_module_enable', true);
        include(dirname(__FILE__).'/sql/install.php');


        return parent::install() &&
            $this->registerHook('header') && $this->registerHook('moduleRoutes') && $this->installTab();
    }

    public function uninstall()
    {
        include(dirname(__FILE__).'/sql/uninstall.php');

        return parent::uninstall()   &&  $this->unregisterHook('header') && $this->unregisterHook('moduleRoutes')  && $this->uninstallTab();
    }
    public function installTab()
    {
        $tab = new Tab();
        $tab->active = 1;
        if (true === Tools::version_compare(_PS_VERSION_, '1.7.0.0', '>=')) {
            $tab->id_parent = 0;
        } else {
            $tab->id_parent = 0;
        }
        $tab->class_name = 'AdminParentPasswordProtected';
        $tab->name = array();
        foreach (Language::getLanguages(true) as $lang) {
            $tab->name[$lang['id_lang']] = $this->l('Addify Password Protected');
        }
        $tab->add();

        $tab = new Tab();
        $tab->active = 1;
        $tab->id_parent = (int)Tab::getIdFromClassName('AdminParentPasswordProtected');
        ;
        $tab->class_name = 'AdminPasswordProtected';
        $tab->name = array();
        foreach (Language::getLanguages(true) as $lang) {
            $tab->name[$lang['id_lang']] = $this->l('Manage Password Protected');
        }
        $tab->module = $this->name;
        return $tab->add();
    }

    public function uninstallTab()
    {
        $id_tab = (int)Tab::getIdFromClassName('AdminPasswordProtected');
        if ($id_tab) {
            $tab = new Tab($id_tab);
            $tab->delete();
        }
        $id_tab = (int)Tab::getIdFromClassName('AdminParentPasswordProtected');
        if ($id_tab) {
            $tab = new Tab($id_tab);
            return $tab->delete();
        }
        return false;
    }

    public function getContent()
    {
        if (!$this->active) {
            $this->context->controller->errors[] = $this->l('Access Denied...Module is disabled.');
        } else {
            /**
             * If values have been submitted in the form, process.
             */

            $notification = (int)Tools::getValue('notification');

            if($notification == 1){

                $this->context->controller->errors[] = $this->l('Object not found.');

            } elseif ($notification == 2){

                $this->context->controller->errors[] = $this->l('Status update failed.');

            } elseif ($notification == 3){

                $this->context->controller->confirmations[] = $this->l('Status updated successfully.');

            } elseif ($notification == 4){

               $this->context->controller->errors[] = $this->l('Rule cannot be deleted.');

            } elseif ($notification == 5){

                $this->context->controller->confirmations[] = $this->l('Rule deleted successfully.');

            } elseif ($notification == 6){

                $deleted = (int)Tools::getValue('del');

                $this->context->controller->confirmations[] = sprintf($this->l('%s Rules deleted successfully.'), $deleted);

            } elseif ($notification == 7){

                $this->context->controller->errors[] = $this->l('Log cannot be deleted.');

            } elseif ($notification == 8){

                 $this->context->controller->confirmations[] = $this->l('Log deleted successfully.');

            } elseif ($notification == 9){

                $deleted = (int)Tools::getValue('del');

                $this->context->controller->confirmations[] = sprintf($this->l('%s logs deleted successfully.'), $deleted);

            }

            $configUrl =$this->context->link->getAdminLink('AdminModules', true). '&configure=' . $this->name;

            $this->context->smarty->assign(array(
                'configUrl' => $configUrl,
            ));

            $this->postProcess();

            if(Tools::isSubmit('Submitconfig'.$this->name))
            {
              $this->processconfigSave();
            }

            if(Tools::isSubmit('submitconfigwhitelist'.$this->name))
            {
              $this->processconfigSaveWhiteList();
            }

            if (Tools::isSubmit('add'.$this->name) || Tools::isSubmit('update'.$this->name)) {

                $this->context->smarty->assign(array(
        
                    'renderList' => $this->renderForm(),
                ));

                return $this->display(__FILE__,'views/templates/admin/rules.tpl');
            }

            if (Tools::isSubmit('rules'.$this->name)) 
            {
                $this->context->smarty->assign(array(
        
                    'renderList' => $this->renderList(),
                ));

                return $this->display(__FILE__,'views/templates/admin/rules.tpl');
            }

            if (Tools::isSubmit('logs'.$this->name)) 
            {
                $this->context->smarty->assign(array(
            
                    'renderListAccessLog' => $this->renderListAccessLog(),
                ));

                return $this->display(__FILE__,'views/templates/admin/logs.tpl');
            }

            if (Tools::isSubmit('whitelisting'.$this->name)) 
            {
                $this->context->smarty->assign(array(
            
                    'renderconfigForm' => $this->renderconfigFormWhiteList(),
                ));

                return $this->display(__FILE__,'views/templates/admin/whitelisting.tpl');
            }

            $this->context->smarty->assign(array(
           
                'renderconfigForm' => $this->renderconfigForm(),
            ));

            return $this->display(__FILE__,'views/templates/admin/configure.tpl');
        }
    }
     protected function postProcess()
    {
        if (Tools::isSubmit('submitAddifypasswordprotected')) {
            $this->processSave();
        } elseif (Tools::isSubmit('status'.$this->name)) {
            if (!Passwordprotected::setStatus('active', (int)Tools::getValue('id_addifypasswordprotected'))) {

                $notification = 2;
                Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&configure='.$this->name.'&notification='.$notification.'&rulesaddifypasswordprotected');
            } else {
                $notification = 3;
                Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&configure='.$this->name.'&notification='.$notification.'&rulesaddifypasswordprotected');

                $this->context->controller->confirmations[] = $this->l('Status updated successfully.');
            }
        } elseif (Tools::isSubmit('delete'.$this->name)) {
            if (!Validate::isLoadedObject($hideprice = new Passwordprotected((int)Tools::getValue('id_addifypasswordprotected')))) {
                $notification = 1;
                Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&configure='.$this->name.'&notification='.$notification.'&rulesaddifypasswordprotected');
            } else {
                if (!$hideprice->delete()) {
                    $notification = 4;
                    Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&configure='.$this->name.'&notification='.$notification.'&rulesaddifypasswordprotected');
                } else {
                    $notification = 5;
                    Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&configure='.$this->name.'&notification='.$notification.'&rulesaddifypasswordprotected');
                }
            }
        } elseif (Tools::isSubmit('submitBulkdelete'.$this->name)) {
            $addifypasswordprotectedBox = Tools::getValue('addifypasswordprotectedBox');
            if (isset($addifypasswordprotectedBox) && $addifypasswordprotectedBox) {
                $deleted = 0;
                foreach ($addifypasswordprotectedBox as $addifypasswordprotected) {
                    if (!Validate::isLoadedObject($passwordprotected = new Passwordprotected((int)$addifypasswordprotected))) {
                        $notification = 1;
                        Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&configure='.$this->name.'&notification='.$notification.'&rulesaddifypasswordprotected');
                        break;
                    } else {
                        if ($passwordprotected->delete()) {
                            $deleted++;
                        }
                    }
                }
                if (count($this->context->controller->errors)) {
                    $this->context->controller->errors;
                } else {
                    $notification = 6;
                    Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&configure='.$this->name.'&notification='.$notification.'&rulesaddifypasswordprotected'.'&del='.$deleted);
                }
            }
        } elseif (Tools::isSubmit('delete'.$this->name.'accesslog')) {
            if (!Validate::isLoadedObject($id = new Passwordprotectedaccesslog((int)Tools::getValue('id')))) {
                
            } else {

                if (!$id->delete()) {
                    $notification = 7;
                    Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&configure='.$this->name.'&notification='.$notification.'&logsaddifypasswordprotected');
                } 
                else 
                {
                    $notification = 8;
                    Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&configure='.$this->name.'&notification='.$notification.'&logsaddifypasswordprotected');
                }
            }
        } elseif (Tools::isSubmit('submitBulkdelete'.$this->name.'accesslog')) {
        
            $postBox = Tools::getValue('addifypasswordprotectedaccesslogBox');
            if (isset($postBox) && $postBox) {
                $deleted = 0;
                foreach ($postBox as $posts) {
                    if (!Validate::isLoadedObject($Passwordprotectedaccesslog = new Passwordprotectedaccesslog((int)$posts))) {
                        
                        break;
                    } 
                    else {

                        if ($Passwordprotectedaccesslog->delete()) {
                            $deleted++;
                        }
                    }
                }
                if (count($this->context->controller->errors)) {
                    $this->context->controller->errors;
                } else {
                    $notification = 9;
                    Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&configure='.$this->name.'&notification='.$notification.'&logsaddifypasswordprotected'.'&del='.$deleted);
                }
            }
        }
    }

    protected function renderListAccessLog()
    {
        $fields_list = array(
            'id' => array(
                'title' => $this->l('ID'),
                'width' => 120,
                'type' => 'text',
                'search' => false,
                'orderby' => false
            ),
            'user_id' => array(
                'title' => $this->l('User ID'),
                'width' => 140,
                'type' => 'text',
                'search' => false,
                'orderby' => false
            ),
            'user_name' => array(
                'title' => $this->l('User Name'),
                'width' => 140,
                'type' => 'text',
                'search' => false,
                'orderby' => false
            ),
            'page_visited' => array(
                'title' => $this->l('Page Visited'),
                'width' => 140,
                'type' => 'text',
                'search' => false,
                'orderby' => false
            ),
            'Password_Attempt' => array(
                'title' => $this->l('Password Attempt'),
                'width' => 140,
                'type' => 'text',
                'search' => false,
                'orderby' => false
            ),
            'date_add' => array(
                'title' => $this->l('Date'),
                'width' => 140,
                'type' => 'date',
                'search' => false,
                'orderby' => false
            ),
        );

        // multishop feature
        if (Shop::isFeatureActive()) {
            $fields_list['id_shop'] = array(
                'title' => $this->l('ID Shop'),
                'align' => 'center',
                'width' => 25,
                'type' => 'int'
            );
        }

        $helper = new HelperList();
        $helper->shopLinkType = '';
        $helper->simple_header = false;
        $helper->identifier = 'id';
        $helper->actions = array('delete');
        $helper->bulk_actions = array(
            'delete' => array(
                'text' => $this->l('Delete selected'),
                'icon' => 'icon-trash',
                'confirm' => $this->l('Delete selected items?')
            )
        );
        $helper->listTotal = count(Passwordprotectedaccesslog::getListContent());
        $helper->show_toolbar = true;
        $helper->title = $this->l('Access Logs');
        $helper->table = "addifypasswordprotectedaccesslog";
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name.'&logsaddifypasswordprotected';
        return $helper->generateList(Passwordprotectedaccesslog::getListContent(), $fields_list);
    }

    protected function renderList()
    {
        $fields_list = array(
            'id_addifypasswordprotected' => array(
                'title' => $this->l('ID'),
                'width' => 120,
                'type' => 'text',
                'search' => false,
                'orderby' => false
            ),
            'title' => array(
                'title' => $this->l('Title'),
                'width' => 140,
                'type' => 'text',
                'search' => false,
                'orderby' => false
            ),
            'priority' => array(
                'title' => $this->l('Priority'),
                'width' => 140,
                'type' => 'text',
                'search' => false,
                'orderby' => false
            ),
            'active' => array(
                'title' => $this->l('Status'),
                'width' => 140,
                'active' => 'status',
                'type' => 'bool',
                'search' => false,
                'orderby' => false
            ),
            'date_add' => array(
                'title' => $this->l('Added Date'),
                'width' => 140,
                'type' => 'date',
                'search' => false,
                'orderby' => false
            ),
            'date_upd' => array(
                'title' => $this->l('Update Date'),
                'width' => 140,
                'type' => 'date',
                'search' => false,
                'orderby' => false
            ),
        );

        // multishop feature
        if (Shop::isFeatureActive()) {
            $fields_list['id_shop'] = array(
                'title' => $this->l('ID Shop'),
                'align' => 'center',
                'width' => 25,
                'type' => 'int'
            );
        }

        $helper = new HelperList();
        $helper->shopLinkType = '';
        $helper->simple_header = false;
        $helper->identifier = 'id_addifypasswordprotected';
        $helper->actions = array('edit', 'delete');
        $helper->bulk_actions = array(
            'delete' => array(
                'text' => $this->l('Delete selected'),
                'icon' => 'icon-trash',
                'confirm' => $this->l('Delete selected items?')
            )
        );
        $helper->listTotal = count(Passwordprotected::getListContent());
        $helper->show_toolbar = true;
        $helper->toolbar_btn['new'] =  array(
            'href' => AdminController::$currentIndex.'&configure='.$this->name.'&add'.$this->name.'&token='.Tools::getAdminTokenLite('AdminModules'),
            'desc' => $this->l('Add new')
        );

        $helper->title = $this->l('Rules');
        $helper->table = $this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;
        return $helper->generateList(Passwordprotected::getListContent(), $fields_list);
    }


    /**
     * Create the form that will be displayed in the configuration of your module.
     */
    protected function renderForm()
    {
        $helper = new HelperForm();

        $helper->show_toolbar = false;
        $helper->show_cancel_button = false;
        $helper->table = 'addifypasswordprotected';
        $helper->module = $this;
        $helper->default_form_language = $this->context->language->id;
        $helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG', 0);

        $helper->identifier = 'id_'.$this->table;
        $helper->submit_action = 'submitAddifypasswordprotected';
        $helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->back_url = $helper->currentIndex.'&token='.$helper->token;
        $products = array();

        if (Tools::getValue('id_addifypasswordprotected')) {
            $hidepriceBlock = new Passwordprotected((int)Tools::getValue('id_addifypasswordprotected'));
            $post_accessories_tab = explode(',', $hidepriceBlock->product);
            foreach ($post_accessories_tab as $id_product) {
                if (!$this->haveThisProduct($id_product, $products) &&
                    $product = Passwordprotected::getProductById($id_product)) {
                    $products[] = $product;
                }
            }
        } else {
            $products = array();
        }
        if ($post_accessories = Tools::getValue('inputRestrictedProducts')) {
            $post_accessories_tab = explode('-', $post_accessories);
            foreach ($post_accessories_tab as $id_product) {
                if (!$this->haveThisProduct($id_product, $products) &&
                    $product = Passwordprotected::getProductById($id_product)) {
                    $products[] = $product;
                }
            }
        }

        $helper->tpl_vars = array(
            'fields_value' => $this->getFormValues(), /* Add values for your inputs */
            'languages' => $this->context->controller->getLanguages(),
            'id_language' => $this->context->language->id,
            'products' => $products,
            'context_link' => Context::getContext()->link,
        );

        return $helper->generateForm(array($this->getConfigForm()));
    }
    public function haveThisProduct($id_product, $products)
    {
        foreach ($products as $product) {
            if ((int)$product['id_product'] == (int)$id_product) {
                return true;
            }
        }
        return false;
    }
    /**
     * Create the structure of your form.
     */
    protected function getConfigForm()
    {

        // Getting Manufacturers
        $Manufacturers_array = Manufacturer::getManufacturers(false,$this->context->language->id, false, false, false);
        $Manufacturers = array();

        foreach ($Manufacturers_array as $Manufacturer) {
            
            $Manufacturers[] = array('name' => $Manufacturer['name'], 'id' => $Manufacturer['id_manufacturer']);
        }
        
        // Getting Suppliers
        $Suppliers_array = Supplier::getSuppliers(false, $this->context->language->id, false, false, false, false);
        $Suppliers = array();

        foreach ($Suppliers_array as $Supplier) {
            
            $Suppliers[] = array('name' => $Supplier['name'], 'id' => $Supplier['id_supplier']);
        }

        if (Tools::getValue('id_addifypasswordprotected')) {
            $passwordprotectBlock = new Passwordprotected((int)Tools::getValue('id_addifypasswordprotected'));
            $selected_categories = explode(',', $passwordprotectBlock->categories);
        } else {
            $selected_categories = array();
        }


        $fields_form = array(
            'form' => array(
                'legend' => array(
                    'title' => $this->l('Settings'),
                    'icon' => 'icon-cogs',
                ),
                'input' => array(
                    array(
                        'type' => 'hidden',
                        'name' => 'id_addifypasswordprotected'
                    ),array(
                        'type'          => 'text',
                        'label'         => $this->l('Title'),
                        'name'          => 'title',
                    ),array(
                        'type'          => 'text',
                        'label'         => $this->l('Priority'),
                        'name'          => 'priority',
                        'validate' => 'isInt',
                        'desc' => $this->l('Value must be numeric.'),

                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Active'),
                        'name' => 'active',
                        'is_bool' => true,
                        'desc' => $this->l('Enable/Disable this rule.'),
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )
                        ),
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Customize Message'),
                        'name' => 'disable_customize_msg',
                        'is_bool' => true,
                        'desc' => $this->l('Enable/Disable customize message.'),
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )
                        ),
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Whole Website'),
                        'name' => 'wholewebsite',
                        'is_bool' => true,
                        'desc' => $this->l('Enable/Disable password for whole website.'),
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )
                        ),
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Group Active'),
                        'name' => 'group_active',
                        'is_bool' => true,
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )
                        ),
                    ),
                    array(
                        'type' => 'group',
                        'label' => $this->l('Group'),
                        'name' => 'groupBox',
                        'values' => Group::getGroups(Context::getContext()->language->id),
                        'info_introduction' => $this->l('You now have three default customer groups.'),
                        'desc' => $this->l('Mark any/all of the customer group(s) which you would like to password protected.'),
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Product Active'),
                        'name' => 'product_active',
                        'is_bool' => true,
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )
                        ),
                    ),
                    array(
                        'type' => 'passwordprotected_product',
                        'label' => $this->l('Search Product'),
                        'name' => 'product',
                        'col' => 6,
                        'prefix' => '<i class="icon-search"></i>',
                        'hint' => $this->l('Product(s) will be password protected for selected product.')
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Categories Active'),
                        'name' => 'category_active',
                        'is_bool' => true,
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )
                        ),
                    ),
                    array(
                        'type'  => 'categories',
                        'label' => $this->l('Categories'),
                        'name'  => 'category',
                        'col' => 6,
                        'tree'  => array(
                            'id' => 'type_category',
                            'use_checkbox' => true,
                            'disabled_categories' => null,
                            'selected_categories' => $selected_categories,
                            'root_category' => Context::getContext()->shop->getCategory()
                        )
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Manufacturer Active'),
                        'name' => 'manufacturer_active',
                        'is_bool' => true,
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )
                        ),
                    ),
                     array(
                        'type' => 'select',
                        'label' => $this->l('Manufacturer'),
                        'name' => 'Manufacturer',
                        'id' => 'Manufacturer',
                        'multiple' => true,
                        'desc' => $this->l('Choose the manufacturer for whom you want to apply for password protected.'),
                        'options' => array(
                            'query' => $Manufacturers,
                            'id' => 'id',
                            'name' => 'name',
                        ),
                        
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Supplier Active'),
                        'name' => 'supplier_active',
                        'is_bool' => true,
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )
                        ),
                    ),
                    array(
                        'type' => 'select',
                        'label' => $this->l('Supplier'),
                        'name' => 'Supplier',
                        'id' => 'Supplier',
                        'multiple' => true,
                        'desc' => $this->l('Choose the supplier for whom you want to apply for password protected.'),
                        'options' => array(
                            'query' => $Suppliers,
                            'id' => 'id',
                            'name' => 'name',
                        ),
                        
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('CMS Active'),
                        'name' => 'cms_active',
                        'is_bool' => true,
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )
                        ),
                    ),
                    array(
                        'type' => 'ppcms_pages',
                        'label' => $this->l('CMS pages'),
                        'name' => 'cms[]',
                        'values' => Passwordprotected::getCmsPages(),
                        'desc' => $this->l('Please mark every page that you want to password protected.')
                    )
                    ,array(
                        'type' => 'passwordprotected_password',
                        'label' => $this->l('Password'),
                        'name' => 'password[]',
                        'values' => Passwordprotected::getCmsPages(),
                        'desc' => $this->l('Add password for rule setting.')
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Rule Scheduling'),
                        'is_bool' => true,
                        'name' => 'switch_rule_scheduling',
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )

                           ),
                        ),
                    array(
                        'type'          => 'date',
                        'label'         => $this->l('Rule Validity From'),
                        'name'          => 'Validity_from',
                        'desc' => $this->l('Enter minimum date.'),
                    ),
                    array(
                        'type'          => 'date',
                        'label'         => $this->l('Rule Validity To'),
                        'name'          => 'Validity_to',
                        'desc' => $this->l('Enter maximum date.'),
                    ),


                ),
                'submit' => array(
                    'title' => $this->l('Save'),
                ),
                'buttons' => array(
                    'cancel' => array(
                        'title' => $this->l('Cancel'),
                        'class' => 'btn btn-default',
                        'icon' => 'process-icon-cancel',
                        'href' => AdminController::$currentIndex.'&configure='.$this->name.'&token='.Tools::getAdminTokenLite('AdminModules').'&rulesaddifypasswordprotected',
                    ),
                )
            ),
        );

        if (Shop::isFeatureActive()) {
            $fields_form['input'][] = array(
                'type' => 'shop',
                'label' => $this->l('Shop association'),
                'name' => 'checkBoxShopAsso',
            );
        }
        return $fields_form;
    }

    /**
     * Set values for the inputs.
     */
    protected function getFormValues()
    {
        $fields_value = array();
        $accessed_groups_ids = array();


        if (Tools::getValue('id_addifypasswordprotected') && (Tools::isSubmit('submitAddifypasswordprotected') === false)) {
            $passwordProtectedBlock = new Passwordprotected((int)Tools::getValue('id_addifypasswordprotected'));
            $fields_value['id_addifypasswordprotected'] = $passwordProtectedBlock->id;
            $fields_value['title'] = $passwordProtectedBlock->title;
            $fields_value['active'] = (int)$passwordProtectedBlock->active;
            $fields_value['wholewebsite'] = $passwordProtectedBlock->wholewebsite;
            $fields_value['groupBox'] = explode(',', $passwordProtectedBlock->groups);
            $fields_value['product'] = explode(',', $passwordProtectedBlock->product);
            $fields_value['priority'] = $passwordProtectedBlock->priority;
            $fields_value['category'] = explode(',', $passwordProtectedBlock->categories);
            $fields_value['cms'] = explode(',', $passwordProtectedBlock->cms_pages);
            $fields_value['passwords'] = explode(',', $passwordProtectedBlock->passwords);
            $fields_value['Validity_from'] = $passwordProtectedBlock->Validity_from;
            $fields_value['Validity_to'] = $passwordProtectedBlock->Validity_to;
            $fields_value['switch_rule_scheduling'] = $passwordProtectedBlock->switch_rule_scheduling;
            
            if (!$passwordProtectedBlock->Supplier) 
            {
                $fields_value['Supplier[]']  = '';
            }
            else
            {
                $fields_value['Supplier[]']  = explode(",",$passwordProtectedBlock->Supplier);
            }
            if (!$passwordProtectedBlock->Manufacturer) 
            {
                $fields_value['Manufacturer[]']  = '';
            }
            else
            {
                $fields_value['Manufacturer[]']  = explode(",",$passwordProtectedBlock->Manufacturer);
            }
            $fields_value['disable_customize_msg'] = $passwordProtectedBlock->disable_customize_msg;

            $fields_value['group_active'] = $passwordProtectedBlock->group_active;
            $fields_value['product_active'] = $passwordProtectedBlock->product_active;
            $fields_value['category_active'] = $passwordProtectedBlock->category_active;
            $fields_value['manufacturer_active'] = $passwordProtectedBlock->manufacturer_active;
            $fields_value['supplier_active'] = $passwordProtectedBlock->supplier_active;
            $fields_value['cms_active'] = $passwordProtectedBlock->cms_active;
            
            $accessed_groups_ids= $fields_value['groupBox'];
        } else {

            $fields_value['id_addifypasswordprotected'] = Tools::getValue('id_addifypasswordprotected');
            $fields_value['active'] = (int)Tools::getValue('active');
            $fields_value['priority'] = Tools::getValue('priority');
            $fields_value['title'] = Tools::getValue('title');
            $fields_value['wholewebsite'] = (int)Tools::getValue('wholewebsite');
            $fields_value['Validity_from']   = Tools::getValue('Validity_from');
            $fields_value['Validity_to']   = Tools::getValue('Validity_to');
            $fields_value['switch_rule_scheduling']   = Tools::getValue('switch_rule_scheduling');
            $fields_value['disable_customize_msg']   = Tools::getValue('disable_customize_msg');

            $fields_value['group_active']   = Tools::getValue('group_active');
            $fields_value['product_active']   = Tools::getValue('product_active');
            $fields_value['category_active']   = Tools::getValue('category_active');
            $fields_value['manufacturer_active']   = Tools::getValue('manufacturer_active');
            $fields_value['supplier_active']   = Tools::getValue('supplier_active');
            $fields_value['cms_active']   = Tools::getValue('cms_active');

            $fields_value['redirect'] = (int)Tools::getValue('redirect');
            if (!Tools::getValue('groupBox')) {
                $fields_value['groupBox'] =  Tools::getValue('groupBox');
            } else {
                $fields_value['groupBox'] = implode(',', Tools::getValue('groupBox'));
            }

            if (!Tools::getValue('product')) {
                $fields_value['product'] = Tools::getValue('product');
            } else {
                $fields_value['product'] = implode(',', Tools::getValue('product'));
            }
            if (!Tools::getValue('cms')) {
                $fields_value['cms_pages'] = Tools::getValue('cms');
            } else {
                $fields_value['cms_pages'] = implode(',', Tools::getValue('cms'));
            }

            if (Tools::getValue('category')) {
                $fields_value['category'] = implode(',', Tools::getValue('category'));
            } else {
                $fields_value['category'] ='' ;
            }
            if (Tools::getValue('passwords')) {
                $fields_value['passwords'] = implode(',', array_unique(Tools::getValue('passwords')));
            } else {
                $fields_value['passwords'] ='' ;
            }

            if (!Tools::getValue('Supplier')) 
            {
                $fields_value['Supplier[]']  = Tools::getValue('Supplier[]');
            }
            else
            {
                $fields_value['Supplier']  = implode(",",Tools::getValue('Supplier'));
            }

            if (!Tools::getValue('Manufacturer')) 
            {
                $fields_value['Manufacturer[]']  = Tools::getValue('Manufacturer[]');
            }
            else
            {
                $fields_value['Manufacturer']  = implode(",",Tools::getValue('Manufacturer'));
            }
            $accessed_groups_ids=  Tools::getValue('groupBox');
        }
        if (!is_array($accessed_groups_ids)) {
            $accessed_groups_ids = array();
        }
        // Added values of object Group
        $groups = Group::getGroups($this->context->language->id);
        if (empty($accessed_groups_ids)) {
            $preselected = array(Configuration::get('PS_UNIDENTIFIED_GROUP'), Configuration::get('PS_GUEST_GROUP'), Configuration::get('PS_CUSTOMER_GROUP'));
            $accessed_groups_ids = array_merge($accessed_groups_ids, $preselected);
        }
        foreach ($groups as $group) {
            $fields_value['groupBox_'.$group['id_group']] = (isset($accessed_groups_ids) && $accessed_groups_ids)? Tools::getValue('groupBox_'.$group['id_group'], (in_array($group['id_group'], $accessed_groups_ids))) : true;
        }

        return $fields_value;
    }
    /**
     * Save form data.
     */
    protected function processSave()
    {

        $call_back = 'add';
        $form_values = $this->getFormValues();

        if (!isset($form_values) && !$form_values) {
            return $this->context->controller->errors[] = $this->l('Empty post values.');
        }
        if (!is_numeric($form_values['priority'])) {
            $this->context->controller->errors[] = $this->l('Priority value is not valid .');
        }

        if (empty($form_values['groupBox'])) {
            $this->context->controller->errors[] = $this->l('Group is empty.');
        }

        if (!empty($form_values['Validity_from'])) {
            if (!Validate::isDate($form_values['Validity_from'])) {
                $this->context->controller->errors[] = $this->l('Rule Validity from Date is not valid.');
            }
        }
        if (!empty($form_values['Validity_to'])) {
            if (!Validate::isDate($form_values['Validity_to'])) {
                $this->context->controller->errors[] = $this->l('Rule Validity to Date is not valid.');
            }
        }


        if (count($this->context->controller->errors)) {
            return $this->context->controller->errors;
        }

        if (($id_addifyextendedhideprice = Tools::getValue('id_addifypasswordprotected'))) {
            $call_back = 'update';
            $passwordProtected = new Passwordprotected((int)$id_addifyextendedhideprice);
        } else {
            $passwordProtected = new Passwordprotected();
        }

        if (!$form_values['product_active']) {
            $form_values['product']='';
        }
        if (!$form_values['category_active']) {
            $form_values['category']='';
        }
        if (!$form_values['manufacturer_active']) {
            $form_values['Manufacturer']='';
        }
        if (!$form_values['supplier_active']) {
            $form_values['Supplier']='';
        }
        if (!$form_values['cms_active']) {
            $form_values['cms_pages']='';
        }

        if ($form_values['wholewebsite']) {
            $form_values['product']='';
            $form_values['category']='';
            $form_values['cms_pages']='';
            $form_values['Supplier']='';
            $form_values['Manufacturer']='';

        }
        $passwordProtected->title = $form_values['title'];
        $passwordProtected->active = $form_values['active'];
        $passwordProtected->groups = $form_values['groupBox'];
        $passwordProtected->product = $form_values['product'];
        $passwordProtected->categories = $form_values['category'];
        $passwordProtected->priority = $form_values['priority'];
        $passwordProtected->cms_pages = $form_values['cms_pages'];
        $passwordProtected->passwords = $form_values['passwords'];
        $passwordProtected->wholewebsite = $form_values['wholewebsite'];
        $passwordProtected->Validity_from = $form_values['Validity_from'];
        $passwordProtected->switch_rule_scheduling = $form_values['switch_rule_scheduling'];
        $passwordProtected->Validity_to = $form_values['Validity_to'];
        $passwordProtected->Supplier     = $form_values['Supplier'];
        $passwordProtected->Manufacturer     = $form_values['Manufacturer'];
        $passwordProtected->disable_customize_msg     = $form_values['disable_customize_msg'];

        $passwordProtected->group_active     = $form_values['group_active'];
        $passwordProtected->product_active     = $form_values['product_active'];
        $passwordProtected->category_active     = $form_values['category_active'];
        $passwordProtected->manufacturer_active     = $form_values['manufacturer_active'];
        $passwordProtected->supplier_active     = $form_values['supplier_active'];
        $passwordProtected->cms_active     = $form_values['cms_active'];


        if (!call_user_func(array($passwordProtected, $call_back))) {
            $this->context->controller->errors = sprintf($this->l('Something went wrong while performing operation %s'), $call_back);
        } else {
            $this->flushCache();

            if($call_back=='add')
            {
                 Tools::redirectAdmin($this->context->link->getAdminLink('AdminModules', true) . '&conf=3&configure=' . $this->name . '&tab_module=' . $this->tab . '&module_name=' . $this->name.'&rulesaddifypasswordprotected');
            }
            else
            {
                Tools::redirectAdmin($this->context->link->getAdminLink('AdminModules', true) . '&conf=4&configure=' . $this->name . '&tab_module=' . $this->tab . '&module_name=' . $this->name.'&rulesaddifypasswordprotected');
            }
        }
    }

    protected function renderconfigForm()
    {
        $fields_form = array(
            'form' => array(
                'legend' => array(
                    'title' => $this->l('General Settings'),
                    'icon' => 'icon-cogs'
                ),
           
                'input' => array(

                        array(
                        'type' => 'switch',
                        'label' => $this->l('Module Active'),
                        'name' => 'addifypasswordprotected_module_enable',
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )

                           ),
                        ),
                        array(
                        'type' => 'switch',
                        'label' => $this->l('Global Password'),
                        'name' => 'addifypasswordprotected_enable_password',
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )

                           ),
                        ),
                        array(
                            'type'          => 'text',
                            'label'         => $this->l('Password'),
                            'name'          => 'addifypasswordprotected_password',
                            'desc' => $this->l('This password will work on all pages all the time.'),
                        ),
                        array(
                        'type' => 'switch',
                        'label' => $this->l('Contact Us'),
                        'name' => 'addifypasswordprotected_contact_us',
                        'desc' => $this->l('If enabled on the protected pages a button should appear for users to send a message to admin.'),
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )

                           ),
                        ),
                        array(
                        'type' => 'switch',
                        'label' => $this->l('Customizable Message'),
                        'name' => 'addifypasswordprotected_enable_customizable_message',
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )

                           ),
                        ),
                        array(
                            'type'          => 'textarea',
                            'label'         => $this->l('Message'),
                            'name'          => 'addifypasswordprotected_customizable_message',
                            'id' => 'addifypasswordprotected_customizable_message',
                            'class' => 'rte',
                            'autoload_rte' => true,
                            'lang' => true,
                        ),
                        array(
                        'type' => 'switch',
                        'label' => $this->l('Email Notification'),
                        'name' => 'addifypasswordprotected_email_notify',
                        'desc' => $this->l('If enable an email should be sent to admin after a unsuccessful attempt.'),
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )

                           ),
                        ),
                        array(
                            'type'          => 'text',
                            'label'         => $this->l('Number Tries'),
                            'name'          => 'addifypasswordprotected_password_tries',
                            'desc' => $this->l('Enter number of consecutive unsuccessful tries.'),
                        ),
                        array(
                        'type' => 'switch',
                        'label' => $this->l('Crawlers'),
                        'name' => 'addifypasswordprotected_crawler',
                        'desc' => $this->l('If enabled search engine crawlers should be able to visit the page for seo.'),
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )

                           ),
                        ),
                        
                    ),
                'submit' => array(
                    'title' => $this->l('Save'),
                ),
            )
        );

        $helper = new HelperForm();
        $helper->show_toolbar = false;
        $helper->module = $this;
        $lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
        $helper->default_form_language = $lang->id;
        $helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
        $helper->identifier = $this->identifier;
        $helper->submit_action = 'Submitconfig'.$this->name;
        $helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->tpl_vars = array(
            'fields_value' => $this->getconfigFormValues(),
            'languages' => $this->context->controller->getLanguages(),
            'id_language' => $this->context->language->id,
            'context_link' => Context::getContext()->link,
        );
       return $helper->generateForm(array($fields_form));
    }

    protected function getconfigFormValues()
    {
        $fields_value = array();

        if((Tools::isSubmit('Submitconfig'.$this->name) === false))
        {
            $fields_value['addifypasswordprotected_password'] = Configuration::get('addifypasswordprotected_password');
            $fields_value['addifypasswordprotected_contact_us'] = Configuration::get('addifypasswordprotected_contact_us');
            $fields_value['addifypasswordprotected_email_notify'] = Configuration::get('addifypasswordprotected_email_notify');
            $fields_value['addifypasswordprotected_crawler'] = Configuration::get('addifypasswordprotected_crawler');
            $fields_value['addifypasswordprotected_module_enable'] = Configuration::get('addifypasswordprotected_module_enable');
            $fields_value['addifypasswordprotected_enable_password'] = Configuration::get('addifypasswordprotected_enable_password');
            $fields_value['addifypasswordprotected_enable_customizable_message'] = Configuration::get('addifypasswordprotected_enable_customizable_message');
            $fields_value['addifypasswordprotected_password_tries'] = Configuration::get('addifypasswordprotected_password_tries');

            foreach (Language::getLanguages(true) as $lang) {
                $fields_value['addifypasswordprotected_customizable_message'][$lang['id_lang']] = Configuration::get('addifypasswordprotected_customizable_message_'.$lang['id_lang']);
            }

        }
        else
        {
            $fields_value['addifypasswordprotected_password'] = Tools::getValue('addifypasswordprotected_password');
            $fields_value['addifypasswordprotected_contact_us'] = Tools::getValue('addifypasswordprotected_contact_us');
            $fields_value['addifypasswordprotected_email_notify'] = Tools::getValue('addifypasswordprotected_email_notify');
            $fields_value['addifypasswordprotected_crawler'] = Tools::getValue('addifypasswordprotected_crawler');
            $fields_value['addifypasswordprotected_module_enable'] = Tools::getValue('addifypasswordprotected_module_enable');
            $fields_value['addifypasswordprotected_enable_password'] = Tools::getValue('addifypasswordprotected_enable_password');
            $fields_value['addifypasswordprotected_enable_customizable_message'] = Tools::getValue('addifypasswordprotected_enable_customizable_message');
            $fields_value['addifypasswordprotected_password_tries'] = Tools::getValue('addifypasswordprotected_password_tries');

            foreach (Language::getLanguages(true) as $lang) {

                $fields_value['addifypasswordprotected_customizable_message_'.$lang['id_lang']] = Tools::getValue('addifypasswordprotected_customizable_message_'.$lang['id_lang']);
            }
        }   

        return $fields_value;
    }

    protected function processconfigSave()
    {
        $form_values = $this->getconfigFormValues();

        Configuration::updateValue('addifypasswordprotected_password', $form_values['addifypasswordprotected_password']);
        Configuration::updateValue('addifypasswordprotected_contact_us', $form_values['addifypasswordprotected_contact_us']);
        Configuration::updateValue('addifypasswordprotected_email_notify', $form_values['addifypasswordprotected_email_notify']);
        Configuration::updateValue('addifypasswordprotected_crawler', $form_values['addifypasswordprotected_crawler']);
        Configuration::updateValue('addifypasswordprotected_module_enable', $form_values['addifypasswordprotected_module_enable']);
        Configuration::updateValue('addifypasswordprotected_enable_password', $form_values['addifypasswordprotected_enable_password']);
        Configuration::updateValue('addifypasswordprotected_enable_customizable_message', $form_values['addifypasswordprotected_enable_customizable_message']);
        Configuration::updateValue('addifypasswordprotected_password_tries', $form_values['addifypasswordprotected_password_tries']);
        

        foreach (Language::getLanguages(true) as $lang) {
            Configuration::updateValue('addifypasswordprotected_customizable_message_'.$lang['id_lang'], $form_values['addifypasswordprotected_customizable_message_'.$lang['id_lang']], true);
        }

        $this->flushCache();

        Tools::redirectAdmin($this->context->link->getAdminLink('AdminModules', true) . '&conf=4&configure=' . $this->name . '&tab_module=' . $this->tab . '&module_name=' . $this->name);
    }


    protected function renderconfigFormWhiteList()
    {
        $fields_form = array(
            'form' => array(
                'legend' => array(
                    'title' => $this->l('Whitelisting'),
                ),
           
                'input' => array(

                        array(
                        'type' => 'switch',
                        'label' => $this->l('User ID Active'),
                        'name' => 'addifypasswordprotected_enable_user_id',
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )

                           ),
                        ),
                        array(
                            'type'          => 'text',
                            'label'         => $this->l('IDs'),
                            'name'          => 'addifypasswordprotected_user_id',
                            'desc' => $this->l('Add users ids to whitelist who will always be able to visit the store for multiple add with commas separated.'),
                        ),

                        array(
                        'type' => 'switch',
                        'label' => $this->l('Email Active'),
                        'name' => 'addifypasswordprotected_enable_user_email',
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )

                           ),
                        ),
                        array(
                            'type'          => 'text',
                            'label'         => $this->l('Email'),
                            'name'          => 'addifypasswordprotecteduser_email',
                            'desc' => $this->l('Add email addresses to whitelist who will always be able to visit the store for multiple add with commas separated.'),
                        ),

                        array(
                        'type' => 'switch',
                        'label' => $this->l('IP Address Active'),
                        'name' => 'addifypasswordprotected_enable_ip_address',
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => true,
                                'label' => $this->l('Enabled')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => false,
                                'label' => $this->l('Disabled')
                            )

                           ),
                        ),
                        array(
                            'type'          => 'text',
                            'label'         => $this->l('IP Address'),
                            'name'          => 'addifypasswordprotected_ip_address',
                            'desc' => $this->l('Add ip addresses to whitelist who will always be able to visit the store for multiple add with commas separated.'),
                        ),
                        
                    ),
                'submit' => array(
                    'title' => $this->l('Save'),
                ),
            )
        );

        $helper = new HelperForm();
        $helper->show_toolbar = false;
        $helper->module = $this;
        $lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
        $helper->default_form_language = $lang->id;
        $helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
        $helper->identifier = $this->identifier;
        $helper->submit_action = 'submitconfigwhitelist'.$this->name;
        $helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->tpl_vars = array(
            'fields_value' => $this->getconfigFormValuesWhiteList(),
            'languages' => $this->context->controller->getLanguages(),
            'id_language' => $this->context->language->id,
            'context_link' => Context::getContext()->link,
        );
       return $helper->generateForm(array($fields_form));
    }

    protected function getconfigFormValuesWhiteList()
    {
        $fields_value = array();

        if((Tools::isSubmit('submitconfigwhitelist'.$this->name) === false))
        {
            $fields_value['addifypasswordprotected_enable_user_id'] = Configuration::get('addifypasswordprotected_enable_user_id');
            $fields_value['addifypasswordprotected_user_id'] = Configuration::get('addifypasswordprotected_user_id');
            $fields_value['addifypasswordprotected_enable_user_email'] = Configuration::get('addifypasswordprotected_enable_user_email');
            $fields_value['addifypasswordprotecteduser_email'] = Configuration::get('addifypasswordprotecteduser_email');
            $fields_value['addifypasswordprotected_enable_ip_address'] = Configuration::get('addifypasswordprotected_enable_ip_address');
            $fields_value['addifypasswordprotected_ip_address'] = Configuration::get('addifypasswordprotected_ip_address');

        }
        else
        {
            $fields_value['addifypasswordprotected_enable_user_id'] = Tools::getValue('addifypasswordprotected_enable_user_id');
            $fields_value['addifypasswordprotected_user_id'] = Tools::getValue('addifypasswordprotected_user_id');
            $fields_value['addifypasswordprotected_enable_user_email'] = Tools::getValue('addifypasswordprotected_enable_user_email');
            $fields_value['addifypasswordprotecteduser_email'] = Tools::getValue('addifypasswordprotecteduser_email');
            $fields_value['addifypasswordprotected_enable_ip_address'] = Tools::getValue('addifypasswordprotected_enable_ip_address');
            $fields_value['addifypasswordprotected_ip_address'] = Tools::getValue('addifypasswordprotected_ip_address');
        }   

        return $fields_value;
    }

    protected function processconfigSaveWhiteList()
    {
        $form_values = $this->getconfigFormValuesWhiteList();

        Configuration::updateValue('addifypasswordprotected_enable_user_id', $form_values['addifypasswordprotected_enable_user_id']);
        Configuration::updateValue('addifypasswordprotected_user_id', $form_values['addifypasswordprotected_user_id']);
        Configuration::updateValue('addifypasswordprotected_enable_user_email', $form_values['addifypasswordprotected_enable_user_email']);
        Configuration::updateValue('addifypasswordprotecteduser_email', $form_values['addifypasswordprotecteduser_email']);
        Configuration::updateValue('addifypasswordprotected_enable_ip_address', $form_values['addifypasswordprotected_enable_ip_address']);
        Configuration::updateValue('addifypasswordprotected_ip_address', $form_values['addifypasswordprotected_ip_address']);

        $this->flushCache();

        Tools::redirectAdmin($this->context->link->getAdminLink('AdminModules', true) . '&conf=4&configure=' . $this->name . '&tab_module=' . $this->tab . '&module_name=' . $this->name.'&whitelistingaddifypasswordprotected');
    }

    public function flushCache()
    {
        Tools::clearSmartyCache();
        Tools::clearXMLCache();
        Media::clearCache();
        Tools::generateIndex();
        if (true === Tools::version_compare(_PS_VERSION_, '1.7.0.0', '>=') &&
            is_callable(array('Tools', 'clearAllCache'))) {
            Tools::clearAllCache();
        }
    }

    public function getUserIpAddr(){
        //whether ip is from share internet
        if (!empty($_SERVER['HTTP_CLIENT_IP']))   
          {
            $ip_address = $_SERVER['HTTP_CLIENT_IP'];
          }
        //whether ip is from proxy
        elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))  
          {
            $ip_address = $_SERVER['HTTP_X_FORWARDED_FOR'];
          }
        //whether ip is from remote address
        else
          {
            $ip_address = $_SERVER['REMOTE_ADDR'];
          }
        return $ip_address;
    }

    public function hookHeader($params)
    {
        if (!Configuration::get('addifypasswordprotected_module_enable')) {
            return;
        }

        if (!$this->active) {
            return;
        }

        if(!Configuration::get('addifypasswordprotected_crawler') && $_SERVER['HTTP_USER_AGENT'] == 'googlebot'){
            return;
        }

        $type = Dispatcher::getInstance()->getController();
       
        if (($type === 'authentication' || $type === 'registration' || $type === 'password') && (!Tools::getValue('create_account'))) {

            return;
        }

        $this->preCheckAccess();
        $this->checkAccess();
    }
    public function getRestrictedProducts($prefix, $remove = false)
    {
         $data = Passwordprotected::getRestrictedProducts();


        if ($data!="" and $data!=",") {
            if ($remove) {
                return  $prefix.'.`id_product` NOT IN (' . $data . ')';
            }
            return ' AND '.$prefix.'.`id_product` NOT IN (' . $data . ')';
        } else {
            return;
        }
    }
    /**
     * updated: 15/11/2022
     * checks if the password in BO rule is still matching with FO.
     * **/
    protected function checkPswd()
    {

        $global_password = Configuration::get('addifypasswordprotected_password');
        $enable_password = Configuration::get('addifypasswordprotected_enable_password');
        $user_id = explode(",", Configuration::get('addifypasswordprotected_user_id'));
        $enable_user_id = Configuration::get('addifypasswordprotected_enable_user_id');
        $user_email = explode(",", Configuration::get('addifypasswordprotecteduser_email'));
        $enable_user_email = Configuration::get('addifypasswordprotected_enable_user_email');
        $ip_address = explode(",", Configuration::get('addifypasswordprotected_ip_address'));
        $enable_ip_address = Configuration::get('addifypasswordprotected_enable_ip_address');
        $global_password_check = 0;
        $user_id_check = 0;
        $ip_address_check = 0;
        $user_email_check = 0;

        if($this->context->cookie->passwordportectedpasswholeemail){

            if (Configuration::get('addifypasswordprotecteduser_email') && $enable_user_email) {
                $customerId = (int)$this->context->customer->id;
                $customer = new Customer($customerId);
                if (is_object($customer)) {
                    if ($customer->email) {
                        if (in_array($customer->email, $user_email)) {
                            $user_email_check =1;
                        }
                    }
                }
            }

            if($user_email_check){
                return true;
            }else{
                $this->context->cookie->__unset('passwordportectedpasswholeemail');
            }
        }

        if($this->context->cookie->passwordportectedpasswholeipaddress){

            if (Configuration::get('addifypasswordprotected_ip_address') && $enable_ip_address) {
                $curr_ip = $this->getUserIpAddr(); 
                if (in_array($curr_ip, $ip_address)) {
                    $ip_address_check =1;
                }
            }

            if($ip_address_check){
                return true;
            }else{
                $this->context->cookie->__unset('passwordportectedpasswholeipaddress');
            }
        }
        

        if($this->context->cookie->passwordportectedpasswholeuserid){
            
            if (Configuration::get('addifypasswordprotected_user_id') && $enable_user_id) {
                $customerId = (int)$this->context->customer->id;
                $customer = new Customer($customerId);
                if (is_object($customer)) {
                    if (in_array($customerId, $user_id)) {
                        $user_id_check =1;
                    }
                }
            }

            if($user_id_check){
                return true;
            }else{
                $this->context->cookie->__unset('passwordportectedpasswholeuserid');
            }
        }

        if($this->context->cookie->pswd_global){

            $pswdd = $this->context->cookie->pswd_global;
            $pswd = (array) json_decode($pswdd);

            if ($global_password && $enable_password) {
                if ($pswd['pswd'] == $global_password) {
                    $global_password_check = 1;
                }
            }

            if($global_password_check){
                return true;
            }else{
                $this->context->cookie->__unset('passwordportectedpasswholewebglobal');
            }
        }

        if($this->context->cookie->pswd){
            $pswdd = $this->context->cookie->pswd;
            $pswd = (array) json_decode($pswdd);
            $currdata = Passwordprotected::checkPassword($pswd['id'], $pswd['pswd']);
            if($currdata){
                return true;
            } else {
                $this->context->cookie->__unset('pswd');
                $this->context->cookie->__unset('passwordportectedpasslogs');
                return false;
            }
        } 
    }

    protected function checkAccess()
    {
        $type = Dispatcher::getInstance()->getController();
        $groups = array(Group::getCurrent()->id);
        $newArray = array('product'=>'product','category'=>'categories','cms'=>'cms_pages');
        if (!empty($type) && in_array($type, array('product', 'category', 'cms'))) {
            $context = $this->context;
            $value = (int)Tools::getValue('id_' . $type);
            $skip = false;

            if ($passwordportectedpass = $context->cookie->passwordportectedpass) {
                $passwordportectedpass = (array) json_decode($passwordportectedpass);


                if ($type == 'product') {
                    if (in_array($value, explode(',', $passwordportectedpass['products']))) {
                        $skip = true;
                    }
                    $catas = Product::getProductCategoriesFull($value);
                    foreach ($catas as $key => $cata) {
                        if (in_array($cata['id_category'], explode(',', $passwordportectedpass['categories']))) {
                            $skip = true;
                        }
                    }

                    $product = new Product((int)$value);
                    $id_manufacturer = $product->id_manufacturer;
                    $id_supplier = $product->id_supplier;
                    if (in_array($id_manufacturer, explode(',', $passwordportectedpass['Manufacturer']))) {
                        $skip = true;
                    }
                    if (in_array($id_supplier, explode(',', $passwordportectedpass['Supplier']))) {
                        $skip = true;
                    }
                } else if ($type == "category") {
                    if (in_array($value, explode(',', $passwordportectedpass['categories']))) {
                        $skip = true;
                    }
                } else {
                    if (in_array($value, explode(',', $passwordportectedpass['cms_pages']))) {
                        $skip = true;
                    }
                }
            }

            if(!$this->checkPswd()){
                $skip = false;
            }

            if($this->context->cookie->passwordportectedpasswholewebglobal){
                $skip = true;
            }

            if($this->context->cookie->passwordportectedpasswholeuserid){
                $skip = true;
            }

            if($this->context->cookie->passwordportectedpasswholeemail){
                $skip = true;
            }

            if($this->context->cookie->passwordportectedpasswholeipaddress){
                $skip = true;
            }

            if (!$skip) {
                $accessData = Passwordprotected::checkAccess(
                    $groups,
                    $newArray[$type],
                    $value
                );

                if ($type == 'product') {
                     $link = $context->link->getProductLink($value);
                } else if ($type == "category") {
                    $link = $context->link->getCategoryLink($value);
                } else {
                    $link = $context->link->getCMSLink($value);
                }
                if ($accessData) {
                    $pp_id = array('id' => $accessData['id_addifypasswordprotected'], 'url' => $link,'wholeweb'=>false);
                    $context->cookie->__set('ppdata', json_encode($pp_id));
                    Tools::redirect($this->context->link->getModuleLink($this->name, 'passwordprotected'));
                }
            }
        }
    }
    protected function preCheckAccess()
    {   
        $type = Dispatcher::getInstance()->getController();

        $contact_us = Configuration::get('addifypasswordprotected_contact_us');

        if ($contact_us) {
            if ($type == 'contact') {
               return;
            }
        }

        if(!$this->checkPswd()){
            $this->context->cookie->passwordportectedpasswholeweb = false;
        }

        if ($type=='passwordprotected' or $this->context->cookie->passwordportectedpasswholeweb) {
        } else {
            $groups = $this->context->customer->getGroups();

            $accessData = Passwordprotected::preCheckAccess(
                $groups
            );

            if ($accessData) {
                $link      = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
                $pp_id = array('id' => $accessData['id_addifypasswordprotected'], 'pswd' => $accessData['passwords'], 'url' => $link, 'wholeweb' => true);
                $this->context->cookie->__set('ppdata', json_encode($pp_id));

                Tools::redirect($this->context->link->getModuleLink($this->name, 'passwordprotected'));
            }
        }
    }
    public function hookModuleRoutes()
    {
        return array(
            'module-' . $this->name . '-passwordprotected' => array(
                'controller' => 'passwordprotected',
                'rule' => 'passwordprotected',
                'keywords' => array(),
                'params' => array(
                    'fc' => 'module',
                    'module' => $this->name,
                ),
            ),
        );
    }
}
