<?php
/**
 * 2019 Addify
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    Addify
 *  @copyright 2019 Addify
 *  @license   http://opensource.org/licenses/afl-3.0.php
 */

if (!defined('_PS_VERSION_')) {
    exit;
}
class Passwordprotected extends ObjectModel
{
    public $id;

    public $active;


    public $title;

    public $cms_pages;

    public $categories;

    public $groups;

    public $product;

    public $id_shop;

    public $date_upd;

    public $date_add;

    public $displaytext;

    public $priority;

    public $passwords;

    public $wholewebsite;

    public $Manufacturer;
    public $Supplier;
    public $disable_customize_msg;
    public $Validity_from;
    public $switch_rule_scheduling;
    public $Validity_to;

    public $group_active;
    public $product_active;
    public $category_active;
    public $manufacturer_active;
    public $supplier_active;
    public $cms_active;

    /**
     * @see ObjectModel::$definition
     */
    public static $definition = array(
        'table'     => 'addifypasswordprotected',
        'primary'   => 'id_addifypasswordprotected',
        'multilang' => false,
        'fields'    => array(
            'active'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'wholewebsite'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'priority'  => array('type' => self::TYPE_INT),
            'date_upd' => array('type' => self::TYPE_DATE, 'validate' => 'isDate'),
            'date_add'   => array('type' => self::TYPE_DATE, 'validate' => 'isDate'),
            'categories' => array('type' => self::TYPE_HTML),
            'groups' => array('type' => self::TYPE_HTML),
            'cms_pages' => array('type' => self::TYPE_HTML),
            'title' => array('type' => self::TYPE_HTML),
            'product' => array('type' => self::TYPE_HTML),
            'passwords' => array('type' => self::TYPE_HTML),
            'id_shop' => array('type' => self::TYPE_HTML),
            'Validity_from'          => array('type' => self::TYPE_HTML),
            'switch_rule_scheduling'       =>   array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'Validity_to'          => array('type' => self::TYPE_HTML),
            'Manufacturer'          => array('type' => self::TYPE_HTML),
            'Supplier'          => array('type' => self::TYPE_HTML),
            'disable_customize_msg'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'group_active'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'product_active'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'category_active'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'manufacturer_active'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'supplier_active'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'cms_active'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
        )
    );
    public static function getListContent()
    {
        return Db::getInstance()->executeS('
            SELECT *
            FROM `'._DB_PREFIX_.'addifypasswordprotected` ');
    }
    public static function searchHidePriceProduct()
    {
        $query = Tools::getValue('q', false);
        if (!$query or $query == '' or Tools::strlen($query) < 1) {
            die();
        }

        /*
         * In the SQL request the "q" param is used entirely to match result in database.
         * In this way if string:"(ref : #ref_pattern#)" is displayed on the return list,
         * they are no return values just because string:"(ref : #ref_pattern#)"
         * is not write in the name field of the product.
         * So the ref pattern will be cut for the search request.
         */
        if ($pos = strpos($query, ' (ref:')) {
            $query = Tools::substr($query, 0, $pos);
        }

        $excludeIds = Tools::getValue('excludeIds', false);
        if ($excludeIds && $excludeIds != 'NaN') {
            $excludeIds = implode(',', array_map('intval', explode(',', $excludeIds)));
        } else {
            $excludeIds = '';
            $excludePackItself= Tools::getValue('packItself', false);
        }

        // Excluding downloadable products from packs because download from pack is not supported
        $excludeVirtuals = (bool)Tools::getValue('excludeVirtuals', true);
        $exclude_packs = (bool)Tools::getValue('exclude_packs', true);

        $context = Context::getContext();

        $sql = 'SELECT p.`id_product`, pl.`link_rewrite`, p.`reference`, pl.`name`, image_shop.`id_image` id_image, il.`legend`, p.`cache_default_attribute`
                FROM `'._DB_PREFIX_.'product` p
                '.Shop::addSqlAssociation('product', 'p').'
                LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (pl.id_product = p.id_product AND pl.id_lang = '.(int)$context->language->id.Shop::addSqlRestrictionOnLang('pl').')
                LEFT JOIN `'._DB_PREFIX_.'image_shop` image_shop
                    ON (image_shop.`id_product` = p.`id_product` AND image_shop.cover=1 AND image_shop.id_shop='.(int)$context->shop->id.')
                LEFT JOIN `'._DB_PREFIX_.'image_lang` il ON (image_shop.`id_image` = il.`id_image` AND il.`id_lang` = '.(int)$context->language->id.')
                WHERE (pl.name LIKE \'%'.pSQL($query).'%\' OR p.reference LIKE \'%'.pSQL($query).'%\')'.
            (!empty($excludeIds) ? ' AND p.id_product NOT IN ('.$excludeIds.') ' : ' ').
            (!empty($excludePackItself) ? ' AND p.id_product <> '.$excludePackItself.' ' : ' ').
            ($excludeVirtuals ? 'AND NOT EXISTS (SELECT 1 FROM `'._DB_PREFIX_.'product_download` pd WHERE (pd.id_product = p.id_product))' : '').
            ($exclude_packs ? 'AND (p.cache_is_pack IS NULL OR p.cache_is_pack = 0)' : '').
            ' GROUP BY p.id_product';

        $items = Db::getInstance()->executeS($sql);

        if ($items) {
            foreach ($items as $item) {
                $item['name'] = str_replace('|', '&#124;', $item['name']);
                echo trim($item['name']).(!empty($item['reference']) ? ' (ref: '.$item['reference'].')' : '').'|'.(int)($item['id_product'])."\n";
            }
        }
        die();
    }
    public static function getProductById($id_product)
    {
        return Db::getInstance()->getRow('SELECT `id_product`, `name`
            FROM `'._DB_PREFIX_.'product_lang` WHERE `id_product` = '.(int)$id_product);
    }
    public static function getTextDisplay($id_addifyextendedhideprice, $lang)
    {
        return Db::getInstance()->getRow('SELECT `displaytext`
            FROM `'._DB_PREFIX_.'addifyextendedhideprice_lang` WHERE `id_addifyextendedhideprice` = '.(int)$id_addifyextendedhideprice.' AND `id_lang` = '.(int)$lang);
    }
    public static function getCmsPages($id_lang = null, $id_shop = null)
    {
        $id_lang = (int)(($id_lang)?: Context::getContext()->language->id);
        $id_shop = (int)(($id_shop)?: Context::getContext()->shop->id);

        $categories = 'SELECT  cc.`id_cms_category`,
            ccl.`name`,
            ccl.`description`,
            ccl.`link_rewrite`,
            cc.`id_parent`,
            cc.`level_depth`,
            NULL as pages
            FROM '._DB_PREFIX_.'cms_category cc
            INNER JOIN '._DB_PREFIX_.'cms_category_lang ccl
                ON (cc.`id_cms_category` = ccl.`id_cms_category`)
            INNER JOIN '._DB_PREFIX_.'cms_category_shop ccs
                ON (cc.`id_cms_category` = ccs.`id_cms_category`)
            WHERE `active` = 1
                AND ccl.`id_lang`= '.(int)$id_lang.'
                AND ccs.`id_shop`= '.(int)$id_shop;

        $pages = Db::getInstance()->executeS($categories);

        foreach ($pages as &$category) {
            $category['pages'] = Db::getInstance()->executeS('SELECT c.`id_cms`,
                c.`position`,
                cl.`meta_title` as title,
                cl.`meta_description` as description,
                cl.`link_rewrite`
                FROM '._DB_PREFIX_.'cms c
                INNER JOIN '._DB_PREFIX_.'cms_lang cl
                    ON (c.`id_cms` = cl.`id_cms`)
                INNER JOIN '._DB_PREFIX_.'cms_shop cs
                    ON (c.`id_cms` = cs.`id_cms`)
                WHERE c.`active` = 1
                AND c.`id_cms_category` = '.(int)$category['id_cms_category'].'
                AND cl.`id_lang` = '.(int)$id_lang.'
                AND cs.`id_shop` = '.(int)$id_shop);
        }

        return $pages;
    }
    public static function checkAccess($groups, $column, $value)
    {

        $today = date("Y-m-d");
            
        $rules = Db::getInstance()->executeS('
            SELECT * FROM `'._DB_PREFIX_.'addifypasswordprotected` WHERE `active` = 1 AND (`product_active` = 1 OR  `cms_active` = 1 OR `category_active` = 1) AND FIND_IN_SET('.(int)$value.',`'.$column.'`) ORDER BY priority ASC');
        if ($rules) {
            foreach ($rules as $rule) {
                if ($rule['switch_rule_scheduling'] == 1) {
                    if (($today >= $rule['Validity_from'] || $rule['Validity_from'] =='' || $rule['Validity_from'] == '0000-00-00') && (
                    $today <= $rule['Validity_to'] || $rule['Validity_to'] =='' || $rule['Validity_to'] == '0000-00-00' ))
                    {
                        if ($rule['group_active'] == 1) {
                            if (!$rule['groups']) {
                                return $rule;
                            } else if ($rule['groups']) {
                                $ruleGroups =  explode(',', $rule['groups']);
                                foreach ($groups as $key => $value) {
                                    if (in_array($value, $ruleGroups)) {
                                        return $rule;
                                    }
                                }
                            }
                        }else{
                            return $rule;
                        }
                    }
                }else{
                    if ($rule['group_active'] == 1) {
                        if (!$rule['groups']) {
                            return $rule;
                        } else if ($rule['groups']) {
                            $ruleGroups =  explode(',', $rule['groups']);
                            foreach ($groups as $key => $value) {
                                if (in_array($value, $ruleGroups)) {
                                    return $rule;
                                }
                            }
                        }
                    }else{
                        return $rule;
                    }
                }
            }
        } else {
            if ($column=="product") {
                $catas = Product::getProductCategoriesFull($value);
                $getArray = array( );
                foreach ($catas as $cata) {
                    $getArray[]= $cata['id_category'];
                }
                 $cat = implode(',', $getArray);
                $rules = Db::getInstance()->executeS('
                    SELECT * FROM `'._DB_PREFIX_.'addifypasswordprotected`  WHERE `active` = 1 AND `category_active` = 1  AND `categories` IN (' . $cat . ') ORDER BY priority ASC');
                if ($rules) {
                    foreach ($rules as $rule) {
                        if ($rule['switch_rule_scheduling'] == 1) {
                            if (($today >= $rule['Validity_from'] || $rule['Validity_from'] =='' || $rule['Validity_from'] == '0000-00-00') && (
                            $today <= $rule['Validity_to'] || $rule['Validity_to'] =='' || $rule['Validity_to'] == '0000-00-00' ))
                            {
                                if ($rule['group_active'] == 1) {
                                    if (!$rule['groups']) {
                                        return $rule;
                                    } else if ($rule['groups']) {
                                        $ruleGroups =  explode(',', $rule['groups']);
                                        foreach ($groups as $key => $value) {
                                            if (in_array($value, $ruleGroups)) {
                                                return $rule;
                                            }
                                        }
                                    }
                                }else{
                                    return $rule;
                                }
                            }
                        }else{
                            if ($rule['group_active'] == 1) {
                                if (!$rule['groups']) {
                                    return $rule;
                                } else if ($rule['groups']) {
                                    $ruleGroups =  explode(',', $rule['groups']);
                                    foreach ($groups as $key => $value) {
                                        if (in_array($value, $ruleGroups)) {
                                            return $rule;
                                        }
                                    }
                                }
                            }else{
                                return $rule;
                            }
                        }
                    }
                }

                $product = new Product((int)$value);
                $id_manufacturer = $product->id_manufacturer;

                $rules = Db::getInstance()->executeS("
                    SELECT * FROM `" . _DB_PREFIX_ . "addifypasswordprotected` WHERE `active` = 1 AND `manufacturer_active` = 1 AND FIND_IN_SET(" . (int)$id_manufacturer . ", `Manufacturer`) ORDER BY priority ASC");
                if ($rules) {
                
                    foreach ($rules as $rule) {
                        if ($rule['switch_rule_scheduling'] == 1) {
                            if (($today >= $rule['Validity_from'] || $rule['Validity_from'] =='' || $rule['Validity_from'] == '0000-00-00') && (
                            $today <= $rule['Validity_to'] || $rule['Validity_to'] =='' || $rule['Validity_to'] == '0000-00-00' ))
                            {
                                if ($rule['group_active'] == 1) {
                                    if (!$rule['groups']) {
                                        return $rule;
                                    } else if ($rule['groups']) {
                                        $ruleGroups =  explode(',', $rule['groups']);
                                        foreach ($groups as $key => $value) {
                                            if (in_array($value, $ruleGroups)) {
                                                return $rule;
                                            }
                                        }
                                    }
                                }else{
                                    return $rule;
                                }
                            }
                        }else{
                            if ($rule['group_active'] == 1) {
                                if (!$rule['groups']) {
                                    return $rule;
                                } else if ($rule['groups']) {
                                    $ruleGroups =  explode(',', $rule['groups']);
                                    foreach ($groups as $key => $value) {
                                        if (in_array($value, $ruleGroups)) {
                                            return $rule;
                                        }
                                    }
                                }
                            }else{
                                return $rule;
                            }
                        }
                    }
                }

                $id_supplier = $product->id_supplier;

                $rules = Db::getInstance()->executeS("
                    SELECT * FROM `" . _DB_PREFIX_ . "addifypasswordprotected` WHERE `active` = 1 AND `supplier_active` = 1 AND FIND_IN_SET(" . (int)$id_supplier . ", `Supplier`) ORDER BY priority ASC");
                if ($rules) {
                   
                    foreach ($rules as $rule) {
                        if ($rule['switch_rule_scheduling'] == 1) {
                            if (($today >= $rule['Validity_from'] || $rule['Validity_from'] =='' || $rule['Validity_from'] == '0000-00-00') && (
                            $today <= $rule['Validity_to'] || $rule['Validity_to'] =='' || $rule['Validity_to'] == '0000-00-00' ))
                            {
                                if ($rule['group_active'] == 1) {
                                    if (!$rule['groups']) {
                                        return $rule;
                                    } else if ($rule['groups']) {
                                        $ruleGroups =  explode(',', $rule['groups']);
                                        foreach ($groups as $key => $value) {
                                            if (in_array($value, $ruleGroups)) {
                                                return $rule;
                                            }
                                        }
                                    }
                                }else{
                                    return $rule;
                                }
                            }
                        }else{
                            if ($rule['group_active'] == 1) {
                                if (!$rule['groups']) {
                                    return $rule;
                                } else if ($rule['groups']) {
                                    $ruleGroups =  explode(',', $rule['groups']);
                                    foreach ($groups as $key => $value) {
                                        if (in_array($value, $ruleGroups)) {
                                            return $rule;
                                        }
                                    }
                                }
                            }else{
                                return $rule;
                            }
                        }
                    }
                }

            }
        }
    }
    public static function preCheckAccess($groups)
    {
        $today = date("Y-m-d");

        $rules = Db::getInstance()->executeS('
            SELECT *
            FROM `'._DB_PREFIX_.'addifypasswordprotected`  WHERE `active` = 1  AND `wholewebsite`=1  ORDER BY priority ASC');
        if ($rules) {
            foreach ($rules as $rule) {
                if ($rule['switch_rule_scheduling'] == 1) {
                    if (($today >= $rule['Validity_from'] || $rule['Validity_from'] =='' || $rule['Validity_from'] == '0000-00-00') && (
                    $today <= $rule['Validity_to'] || $rule['Validity_to'] =='' || $rule['Validity_to'] == '0000-00-00' ))
                    {
                        if ($rule['group_active'] == 1) {
                            if (!$rule['groups']) {
                                return $rule;
                            } else if ($rule['groups']) {
                                $ruleGroups =  explode(',', $rule['groups']);
                                foreach ($groups as $key => $value) {
                                    if (in_array($value, $ruleGroups)) {
                                        return $rule;
                                    }
                                }
                            }
                        }else{
                            return $rule;
                        }
                    }
                }else{
                    if ($rule['group_active'] == 1) {
                        if (!$rule['groups']) {
                            return $rule;
                        } else if ($rule['groups']) {
                            $ruleGroups =  explode(',', $rule['groups']);
                            foreach ($groups as $key => $value) {
                                if (in_array($value, $ruleGroups)) {
                                    return $rule;
                                }
                            }
                        }
                    }else{
                        return $rule;
                    }
                }
            }
        }
    }
    public static function getRestrictedProducts()
    {
        $rules = Db::getInstance()->executeS('
            SELECT *
            FROM `'._DB_PREFIX_.'addifypasswordprotected`  WHERE `active` = 1   ORDER BY priority ASC');
        if ($rules) {
            $context = Context::getContext();
            if ($passwordportectedpass = $context->cookie->passwordportectedpass) {
                $passwordportectedpass = json_decode($passwordportectedpass);
            }
            $productArray = array();
            foreach ($rules as $rule) {
                    $products =  explode(',', $rule['product']);
                foreach ($products as $key => $product) {
                    $productArray[] = $product;
                }
            }
            // if ($passwordportectedpass) {
            //     $passwordportectedpassProduct = explode(',', $passwordportectedpass['products']);
            //     $productArrayNew = array_diff($productArray, $passwordportectedpassProduct);
            // } else {
            //     return implode(',', $productArray);
            // }
            // if ($productArrayNew) {
            //     return implode(',', $productArrayNew);
            // } else {
            //     return 0;
            // }
        }
        // return 0;
    }
    public static function setStatus($status, $id_addifypasswordprotected)
    {
        if (!$id_addifypasswordprotected || empty($status)) {
            return false;
        }
        return (bool)Db::getInstance()->execute('UPDATE '._DB_PREFIX_.self::$definition['table'].'
            SET `'.pSQL($status).'` = !'.pSQL($status).'
            WHERE id_addifypasswordprotected = '.(int)$id_addifypasswordprotected);
    }
    public static function checkPassword($id, $password, $id_shop = '')
    {
        return Db::getInstance()->getRow('
            SELECT *
            FROM `'._DB_PREFIX_.'addifypasswordprotected`  WHERE `active` = 1 and `id_addifypasswordprotected`='.$id.'  AND FIND_IN_SET("'.pSQL($password).'",`passwords`) ORDER BY priority ASC');
    }
     /**
     * updated: 15/11/2022
     * checks if the rule is still active.
     * **/

    public static function checkRule($id)
    {
        $sql = Db::getInstance()->getRow('
            SELECT *
            FROM `'._DB_PREFIX_.'addifypasswordprotected`  WHERE `active` = 1 and `id_addifypasswordprotected`='.$id);
        if(!$sql){
            return false;
        } else {
            return true;
        }
    }

    public static function checkRuleFront($id_rule, $id_group)
    {
        $today = date("Y-m-d");

        $rules = Db::getInstance()->executeS('
            SELECT *
            FROM `'._DB_PREFIX_.'addifypasswordprotected`  WHERE `active` = 1 and `id_addifypasswordprotected`='.$id_rule);
        if ($rules) {
            foreach ($rules as $rule) {
                if ($rule['switch_rule_scheduling'] == 1) {
                    if (($today >= $rule['Validity_from'] || $rule['Validity_from'] =='' || $rule['Validity_from'] == '0000-00-00') && (
                    $today <= $rule['Validity_to'] || $rule['Validity_to'] =='' || $rule['Validity_to'] == '0000-00-00' ))
                    {
                        if ($rule['group_active'] == 1) {
                            if (!$rule['groups']) {
                                return $rule;
                            } else if ($rule['groups']) {
                                $ruleGroups =  explode(',', $rule['groups']);
                                if (in_array($id_group, $ruleGroups)) {
                                    return $rule;
                                }
                            }
                        }else{
                            return $rule;
                        }
                    }
                }else{
                    if ($rule['group_active'] == 1) {
                        if (!$rule['groups']) {
                            return $rule;
                        } else if ($rule['groups']) {
                            $ruleGroups =  explode(',', $rule['groups']);
                            if (in_array($id_group, $ruleGroups)) {
                                return $rule;
                            }
                        }
                    }else{
                        return $rule;
                    }
                }
            }
        }
    }
    public static function getRule($id)
    {
        return Db::getInstance()->getRow('
            SELECT *
            FROM `'._DB_PREFIX_.'addifypasswordprotected`  WHERE `active` = 1 and `id_addifypasswordprotected`='.$id);
    }
}
