<?php
/**
* 2018 Progos Tech
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    Progos Tech
*  @copyright 2018 Progos Tech
*  @license   http://opensource.org/licenses/afl-3.0.php
*/

if (!defined('_PS_VERSION_')) {
    exit;
}
class AddifypasswordprotectedPasswordprotectedModuleFrontController extends ModuleFrontController
{
    public $ssl = true;
    public $display_column_left = false;
    public function init()
    {
        parent::init();
        $this->context = Context::getContext();
    }

    /**
     * @see FrontController::initContent()
     */
    public function initContent()
    {
        parent::initContent();

        $user_id = explode(",", Configuration::get('addifypasswordprotected_user_id'));
        $enable_user_id =  Configuration::get('addifypasswordprotected_enable_user_id');

        $user_email = explode(",", Configuration::get('addifypasswordprotecteduser_email'));
        $enable_user_email = Configuration::get('addifypasswordprotected_enable_user_email');

        $ip_address = explode(",", Configuration::get('addifypasswordprotected_ip_address'));
        $enable_ip_address = Configuration::get('addifypasswordprotected_enable_ip_address');

        $ppdata = $this->context->cookie->ppdata;
        $ppdata = (array) json_decode($ppdata);

        $customerId = (int)$this->context->customer->id;

        $user_id_check = 0;
        if (Configuration::get('addifypasswordprotected_user_id') && $enable_user_id) {
            $customer = new Customer($customerId);
            if (is_object($customer)) {
                if (in_array($customerId, $user_id)) {
                    $user_id_check =1;
                }
            }
        }

        $user_email_check = 0;
        if (Configuration::get('addifypasswordprotecteduser_email') && $enable_user_email) {
            $customer = new Customer($customerId);
            if (is_object($customer)) {
                if ($customer->email) {
                    if (in_array($customer->email, $user_email)) {
                        $user_email_check =1;
                    }
                }
            }
        }

        $ip_address_check = 0;
        if (Configuration::get('addifypasswordprotected_ip_address') && $enable_ip_address) {
            $curr_ip = $this->getUserIpAddr(); 
            if (in_array($curr_ip, $ip_address)) {
                $ip_address_check =1;
            }
        }
        if ($user_id_check) {

            $pswd = array('id' => true, 'pswd' => true);

            $this->context->cookie->__set('pswd', json_encode($pswd));

            $this->context->cookie->__set('passwordportectedpasswholeuserid', true);

            $this->context->cookie->__set('passwordportectedpasswholeweb', true);

            if (!$this->context->cookie->passwordportectedpasslogs) {

                $Password_Attempt = $this->l('Successful');
                $this->saveLogs($Password_Attempt);
                $this->context->cookie->__set('passwordportectedpasslogs', true);
            }

            Tools::redirect($ppdata['url']);
        }
        elseif ($user_email_check) {

            $pswd = array('id' => true, 'pswd' => true);

            $this->context->cookie->__set('pswd', json_encode($pswd));

            $this->context->cookie->__set('passwordportectedpasswholeemail', true);

            $this->context->cookie->__set('passwordportectedpasswholeweb', true);

            if (!$this->context->cookie->passwordportectedpasslogs) {

                $Password_Attempt = $this->l('Successful');
                $this->saveLogs($Password_Attempt);
                $this->context->cookie->__set('passwordportectedpasslogs', true);
            }

            Tools::redirect($ppdata['url']);
        }
        elseif ($ip_address_check) {

            $pswd = array('id' => true, 'pswd' => true);

            $this->context->cookie->__set('pswd', json_encode($pswd));

            $this->context->cookie->__set('passwordportectedpasswholeipaddress', true);

            $this->context->cookie->__set('passwordportectedpasswholeweb', true);

            if (!$this->context->cookie->passwordportectedpasslogs) {

                $Password_Attempt = $this->l('Successful');
                $this->saveLogs($Password_Attempt);
                $this->context->cookie->__set('passwordportectedpasslogs', true);
            }

            Tools::redirect($ppdata['url']);
        }
        elseif (Tools::getValue('pp_password') &&  $this->context->cookie->ppdata) {
            $ppKey = $this->context->cookie->passwordProtectedFormKey;
            if ($ppKey != (Tools::getValue('passwordProtectedKey'))) {
                Tools::redirect('index.php?controller=pagenotfound');
            }
            $valuePost = Tools::getValue('pp_password');
            $ppdata = $this->context->cookie->ppdata;
            $ppdata = (array) json_decode($ppdata);
            
            $currrule = Passwordprotected::checkRule($ppdata['id']);
            if(!$currrule){

                Tools::redirect($ppdata['url']);
            }

            $currdata = Passwordprotected::checkPassword($ppdata['id'], $valuePost);

            $global_password = Configuration::get('addifypasswordprotected_password');
            $enable_password = Configuration::get('addifypasswordprotected_enable_password');

            $global_password_check = 0;
            if ($global_password && $enable_password) {
                if ($valuePost == $global_password) {
                    $global_password_check = 1;
                }
            }

            if ($global_password_check) {

               $pswd = array('id' => true, 'pswd' => $valuePost);

               $this->context->cookie->__set('pswd', json_encode($pswd));
               
                $this->context->cookie->__set('pswd_global', json_encode($pswd));

                $this->context->cookie->__set('passwordportectedpasswholewebglobal', true);

                $this->context->cookie->__set('passwordportectedpasswholeweb', true);

                $this->context->cookie->__unset('ppdata');

                if (!$this->context->cookie->passwordportectedpasslogs) {

                    $Password_Attempt = $this->l('Successful');
                    $this->saveLogs($Password_Attempt);
                    $this->context->cookie->__set('passwordportectedpasslogs', true);
                }

                Tools::redirect($ppdata['url']);
            } 
            elseif ($currdata) {
                 /**
                 * updated: 15/11/2022
                 * **/
                $pswd = array('id' => $ppdata['id'], 'pswd' => $valuePost);
                $this->context->cookie->__set('pswd', json_encode($pswd));

                $this->context->cookie->__unset('ppdata');

                if ($ppdata['wholeweb']) {
                    $this->context->cookie->__set('passwordportectedpasswholeweb', true);

                    if (!$this->context->cookie->passwordportectedpasslogs) {

                        $Password_Attempt = $this->l('Successful');
                        $this->saveLogs($Password_Attempt);
                        $this->context->cookie->__set('passwordportectedpasslogs', true);
                    }

                    Tools::redirect($ppdata['url']);
                } else {
                    if ($passwordportectedpass = $this->context->cookie->passwordportectedpass) {
                        $passwordportectedpass = (array) json_decode($passwordportectedpass);
                        $passwordportectedpass['products'] = $passwordportectedpass['products'] . ',' . $currdata['product'];
                        $passwordportectedpass['categories'] = $passwordportectedpass['categories'] . ',' . $currdata['categories'];
                        $passwordportectedpass['cms_pages'] = $passwordportectedpass['cms_pages'] . ',' . $currdata['cms_pages'];
                        $passwordportectedpass['Manufacturer'] = $passwordportectedpass['Manufacturer'] . ',' . $currdata['Manufacturer'];
                        $passwordportectedpass['Supplier'] = $passwordportectedpass['Supplier'] . ',' . $currdata['Supplier'];
                        $this->context->cookie->__set('passwordportectedpass', json_encode($passwordportectedpass));
                    } else {
                        $dataArray = array('products' => $currdata['product'], 'categories' => $currdata['categories'], 'cms_pages' => $currdata['cms_pages'],'Manufacturer' => $currdata['Manufacturer'],'Supplier' => $currdata['Supplier']);
                        $this->context->cookie->__set('passwordportectedpass', json_encode($dataArray));
                    }

                    if (!$this->context->cookie->passwordportectedpasslogs) {

                        $Password_Attempt = $this->l('Successful');
                        $this->saveLogs($Password_Attempt);
                        $this->context->cookie->__set('passwordportectedpasslogs', true);
                    }

                    Tools::redirect($ppdata['url']);
                }
            }
            else {

                $final_attemp_cookie = 1;

                $password_tries = Configuration::get('addifypasswordprotected_password_tries');

                $complete_tries = false;

                if ($password_tries) {
                    if ($password_tries != 0 ) {

                        $passwordportectedpassattempts = $this->context->cookie->passwordportectedpassattempts;

                        if ($passwordportectedpassattempts) {
                           $final_attemp_cookie = $this->context->cookie->passwordportectedpassattempts + 1;
                        }

                        $this->context->cookie->__set('passwordportectedpassattempts', $final_attemp_cookie, time() + 30, '/');
                       
                        if ($final_attemp_cookie >= $password_tries) {
                            $complete_tries = true;
                        }
                    }
                }

                $email_notify = Configuration::get('addifypasswordprotected_email_notify');

                $customer = new Customer($customerId);
                
                if ($email_notify == 1) {

                    if (is_object($customer)) {
                        if ($customer->email) {
                            $this->sendEmailtoAdmin($customer);
                        }
                    }
                }

                $Password_Attempt = $this->l('Unsuccessful');

                $this->saveLogs($Password_Attempt);

                $passwordProtectedKey = md5(uniqid(microtime(), true));

                $this->context->smarty->assign(array(
                    'ps_version' => _PS_VERSION_,
                    'confirmation' => true,
                    'complete_tries' => $complete_tries,
                    'passwordProtectedKey' => $passwordProtectedKey,

                ));
                $this->context->cookie->__set('passwordProtectedFormKey', $passwordProtectedKey);
            }
        }
        if (!$this->context->cookie->ppdata) {
            Tools::redirect('index.php?controller=pagenotfound');
        } else {

            $password_tries = Configuration::get('addifypasswordprotected_password_tries');

            $complete_tries = false;

            if ($password_tries) {
                if ($password_tries != 0 ) {

                    $passwordportectedpassattempts = $this->context->cookie->passwordportectedpassattempts;
                   
                    if ($passwordportectedpassattempts >= $password_tries) {
                        $complete_tries = true;
                    }
                }
            }

            $ppdata = $this->context->cookie->ppdata;
            $ppdata = (array) json_decode($ppdata);

            $id_group = (int)$this->context->customer->id_default_group;

            $checkrule = Passwordprotected::checkRuleFront((int)$ppdata['id'] ,$id_group);
            if(!$checkrule){

                Tools::redirect($ppdata['url']);
            }

            $disable_customize_msg = 0;
            $currrule = Passwordprotected::getRule((int)$ppdata['id']);
            if ($currrule) {
               $disable_customize_msg = $currrule['disable_customize_msg'];
            }
            $passwordProtectedKey = md5(uniqid(microtime(), true));
            $context=Context::getContext();
            $id_lang = (int)$context->language->id;
            $enable_customizable_message = Configuration::get('addifypasswordprotected_enable_customizable_message');
            $contact_us = Configuration::get('addifypasswordprotected_contact_us');
            $customizable_message = Configuration::get('addifypasswordprotected_customizable_message_'.$id_lang);
            $contact_url = Context::getContext()->link->getPageLink('contact', true);
            $this->context->smarty->assign(array(
                'ps_version' => _PS_VERSION_,
                'passwordProtectedKey' => $passwordProtectedKey,
                'disable_customize_msg' => $disable_customize_msg,
                'enable_customizable_message' => $enable_customizable_message,
                'customizable_message' => $customizable_message,
                'complete_tries' => $complete_tries,
                'contact_us' => $contact_us,
                'contact_url' => $contact_url,
            ));
            $this->context->cookie->__set('passwordProtectedFormKey', $passwordProtectedKey);
            $this->setTemplate($this->module->templateFile);
        }
    }

    public function sendEmailtoAdmin($customer)
    {
        $admin_email = Configuration::get('PS_SHOP_EMAIL');

        Mail::Send(
            (int)$this->context->language->id,
            'messageforadmin',
            $this->l(
                'Unsuccessful Attempt'
            ),
            array(
                '{lastname}' => $customer->lastname,
                '{firstname}' => $customer->firstname,
                '{email}' => $customer->email, 
                '{id}' => $customer->id,
                '{shop_url}' => Context::getContext()->shop->getBaseURL(true),
                '{shop_name}' => Configuration::get('PS_SHOP_NAME'),
            ),
            $admin_email,
            null,
            null,
            null,
            null,
            null,
            _PS_MODULE_DIR_.'addifypasswordprotected/mails/',
            false,
            $this->context->shop->id
        );
    }

    public function getUserIpAddr(){
        //whether ip is from share internet
        if (!empty($_SERVER['HTTP_CLIENT_IP']))   
          {
            $ip_address = $_SERVER['HTTP_CLIENT_IP'];
          }
        //whether ip is from proxy
        elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))  
          {
            $ip_address = $_SERVER['HTTP_X_FORWARDED_FOR'];
          }
        //whether ip is from remote address
        else
          {
            $ip_address = $_SERVER['REMOTE_ADDR'];
          }
        return $ip_address;
    }


    public function saveLogs($Password_Attempt){

        $customerId = (int)$this->context->customer->id;
        $customer = new Customer($customerId);
        $user_name = $this->l('Visitor');
        if (is_object($customer)) {
            if ($customer->email) {
                $user_name = $customer->firstname.$customer->lastname;
            }
        }

        $user_id = $customerId;
        $page_visited = date("Y-m-d");
        $id_shop = $this->context->shop->id;
        $date_add = date("Y-m-d");

        $Passwordprotectedaccesslog = new Passwordprotectedaccesslog();
        $Passwordprotectedaccesslog->user_id = $user_id;
        $Passwordprotectedaccesslog->user_name = $user_name;
        $Passwordprotectedaccesslog->page_visited = $page_visited;
        $Passwordprotectedaccesslog->Password_Attempt = $Password_Attempt;
        $Passwordprotectedaccesslog->id_shop = $id_shop;
        $Passwordprotectedaccesslog->date_add = $date_add;
        $Passwordprotectedaccesslog->save();
    }
}
