<?php
/**
 * 2024 Addify
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    Addify
 *  @copyright 2024 Addify
 *  @license   http://opensource.org/licenses/afl-3.0.php
 */

if (!defined('_PS_VERSION_')) {
    exit;
}

/**
 * This function updates your module from previous versions to the version 1.1,
 * usefull when you modify your database, or register a new hook ...
 * Don't forget to create one file per version.
 */
function upgrade_module_1_4_0($module)
{
    /*
     * Do everything you want right there,
     * You could add a column in one of your module's tables
     */

     $active =1;

    Configuration::updateValue('addifypasswordprotected_module_enable', true);

    $sql[] = 'CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'addifypasswordprotectedaccesslog` (
        `id` int(11) NOT NULL AUTO_INCREMENT,
        `user_id`                        int(11),
        `user_name`                        TEXT,
        `page_visited`                        TEXT,
        `Password_Attempt`                        TEXT,
        `id_shop`                        int(11),
        `date_add`                       DATE,

        PRIMARY KEY  (`id`)
    ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8;';

    foreach ($sql as $query) {
        if (Db::getInstance()->execute($query) == false) {
            return false;
        }
    }

    $Validity_from = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'Validity_from'");
    if (!$Validity_from) {
         Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN Validity_from TEXT');
    }

    $Validity_to = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'Validity_to'");
    if (!$Validity_to) {
         Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN Validity_to TEXT');
    }

    $Manufacturer = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'Manufacturer'");
    if (!$Manufacturer) {
         Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN Manufacturer TEXT');
    }

    $Supplier = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'Supplier'");
    if (!$Supplier) {
         Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN Supplier TEXT');
    }

    $disable_customize_msg = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'disable_customize_msg'");
    if (!$disable_customize_msg) {
         Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN disable_customize_msg TINYINT(2)');
    }

    $manufacturer_active = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'manufacturer_active'");
    if (!$manufacturer_active) {
         Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN manufacturer_active TINYINT(2)');
    }

    $supplier_active = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'supplier_active'");
    if (!$supplier_active) {
         Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN supplier_active TINYINT(2)');
    }

    $group_active = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'group_active'");
    if (!$group_active) {
          Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN group_active TINYINT(2) DEFAULT \'' . (int)$active . '\'');
    }

    $product_active = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'product_active'");
    if (!$product_active) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN product_active TINYINT(2) DEFAULT \'' . (int)$active . '\'');
    }

    $cms_active = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'cms_active'");
    if (!$cms_active) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN cms_active TINYINT(2) DEFAULT \'' . (int)$active . '\'');
    }

    $category_active = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'category_active'");
    if (!$category_active) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN category_active TINYINT(2) DEFAULT \'' . (int)$active . '\'');
    }

    $switch_rule_scheduling = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$module->name."` LIKE 'switch_rule_scheduling'");
    if (!$switch_rule_scheduling) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$module->name.'` ADD COLUMN switch_rule_scheduling TINYINT(2) DEFAULT \'' . (int)$active . '\'');
    }

    return true;
}
