{*
* 2019 Addify
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    Addify
*  @copyright 2019 Addify
*  @license   http://opensource.org/licenses/afl-3.0.php
*}

{extends file="helpers/form/form.tpl"}

{block name="input"}
  {if $input.type == 'ppcms_pages'}
  {foreach $input.values as $cms_category}
    <div id="type_cms" class="panel col-lg-7">
      <div class="panel-heading">
        {$input.label|escape:'htmlall':'UTF-8'} - {$cms_category.name|escape:'htmlall':'UTF-8'}
      </div>
      <table class="table">
        <thead>
        <tr>
          <th>
            <input type="checkbox" name="checkme" id="checkme" class="noborder" onclick="checkDelBoxes(this.form, '{$input.name|escape:'htmlall':'UTF-8'}', this.checked)" />
          </th>
          <th>{l s='ID' mod='addifypasswordprotected'}</th>
          <th>{l s='Name' mod='addifypasswordprotected'}</th>
        </tr>
        </thead>
        <tbody>
        {foreach $cms_category.pages as $key => $page}
          <tr {if $key%2}class="alt_row"{/if}>
            <td>
              <input type="checkbox" class="cmsBox" name="cms[]" id="{$page.id_cms|escape:'htmlall':'UTF-8'}" value="{$page.id_cms|escape:'htmlall':'UTF-8'}" {if isset($fields_value.cms) AND in_array($page.id_cms, $fields_value.cms)}checked="checked"{/if} />
            </td>
            <td class="fixed-width-xs">
              {$page.id_cms|escape:'htmlall':'UTF-8'}
            </td>
            <td>
              <label class="control-label" for="{$page.id_cms|escape:'htmlall':'UTF-8'}">
                {$page.title|escape:'htmlall':'UTF-8'}
              </label>
            </td>
          </tr>
        {/foreach}
        </tbody>
      </table>
    </div>
    <div class="clearfix"></div>
  {/foreach}
    {elseif $input.type == "passwordprotected_product"}
      <div id="type_product" class="col-lg-9">
        <input type="hidden" name="inputRestrictedProducts" id="inputRestrictedProducts" value="{if isset($products) AND $products}{foreach from=$products item=product}{$product.id_product|escape:'htmlall':'UTF-8'}-{/foreach}{/if}" />
        <input type="hidden" name="nameRestrictedProducts" id="nameRestrictedProducts" value="{if isset($products) AND $products}{foreach from=$products item=product}{$product.name|escape:'html':'UTF-8'}¤{/foreach}{/if}" />
        <div id="ajax_choose_product">
          <div class="input-group">
            <input type="text" id="restricted_product_input" name="restricted_product_input" />
            <span class="input-group-addon"><i class="icon-search"></i></span>
          </div>
        </div>
        <p class="help-block">{l s='Search and add product(s) to hide list.' mod='addifypasswordprotected'}</p>
        <br>

        <div id="divRestrictedProducts">
          {if isset($products) AND $products}
            {foreach from=$products item=product}
              <div class="form-control-static panel">
                <button type="button" class="btn btn-danger delRestrictedProducts" name="{$product.id_product|escape:'htmlall':'UTF-8'}">
                  <i class="icon-trash text-danger"></i>
                </button>
                <input type="hidden" name="product[]" value="{$product.id_product|escape:'htmlall':'UTF-8'}">
                {$product.name|escape:'html':'UTF-8'}{if !empty($product.reference)}&nbsp;{l s='(ref: %s)' sprintf=$product.reference mod='addifypasswordprotected'}{/if}
              </div>
            {/foreach}
          {/if}
        </div>
      </div>
      <div class="clearfix"></div>
  {elseif $input.type == "passwordprotected_password"}
    <div id="type_passwrod" class="panel col-lg-7">

      <table class="table" id="pptable">
        <thead>
        <tr>
          <th>{l s='Password' mod='addifypasswordprotected'}</th>
          <th><a href="javascript:void(0)" onclick="addMore()">{l s='Add More' mod='addifypasswordprotected'}</th>
        </tr>
        </thead>
        <tbody>
        {foreach $fields_value.passwords  as $key => $password}
          {if isset($password) AND $password}
          <tr>
            <td>
              <input type="text" class="cmsBox" name="passwords[]" value="{$password|escape:'htmlall':'UTF-8'}"  />
            </td>
            <td >
              <a href="javascript:void(0)" onclick="ppremove(this)" >{l s='Remove' mod='addifypasswordprotected'}</a>
            </td>

          </tr>
          {/if}


        {/foreach}

        </tbody>
      </table>
    </div>
    <table id="passwordTr" style="display: none">
    <tr>
      <td>
        <input type="text" class="cmsBox" name="passwords[]"  />
      </td>
      <td >
        <a href="javascript:void(0)" onclick="ppremove(this)" >{l s='Remove' mod='addifypasswordprotected'}</a>
      </td>

    </tr>
    </table>
    <div class="clearfix"></div>
    {else}
      {$smarty.block.parent}
    {/if}

{/block}

{block name="script"}
  
  var active_type = "{if isset($fields_value) AND isset($fields_value.type)}{$fields_value.type|escape:'htmlall':'UTF-8'}{/if}";
  if (typeof active_type === 'undefined' || active_type === '') {
    active_type = $('#type option:selected').val();
  }

  init_types(active_type);

  $(document).on('change', '#type', function(){
    init_types($(this).val());
  });

  $('#divRestrictedProducts').delegate('.delRestrictedProducts', 'click', function(){
    self.delRestrictedProducts($(this).attr('name'));
  });
  
  var options = {
    minChars: 1,
    autoFill: true,
    max:20,
    matchContains: true,
    mustMatch:false,
    scroll:false,
    cacheLength:0,
    formatItem: function(item) {
      var itemStringToReturn = item[item.length - 1];
      for(var istr = 0; istr < item.length - 1;istr++) {
        itemStringToReturn += " " + item[istr];
      }
      return itemStringToReturn;
    },
    
  };

  $('#restricted_product_input')
  .autocomplete("{$context_link->getAdminLink('AdminPasswordProtected') nofilter}&exclude_packs=0&excludeVirtuals=0",options)
  .result(addProduct);
  $('#restricted_product_input').setOptions({
    extraParams: {
      ajax: true,
      action: 'getProducts',
      excludeIds: getRestrictedProduct()
    }
  });

  function addProduct(event, data, formatted)
  {
    if (data !== null) {
      var productId = data[1];
      var productName = data[0];

      var $divRestrictedProducts = $('#divRestrictedProducts');
      var $inputRestrictedProducts = $('#inputRestrictedProducts');
      var $nameRestrictedProducts = $('#nameRestrictedProducts');

      /* delete product from select + add product line to the div, input_name, input_ids elements */
      $divRestrictedProducts.html($divRestrictedProducts.html() + '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts btn btn-danger" name="' + productId + '"><i class="icon-trash text-danger"></i></button>&nbsp;'+ productName +'</div><input type="hidden" name="product[]" value="' + productId + '">');
      $nameRestrictedProducts.val($nameRestrictedProducts.val() + productName + '¤');
      ($inputRestrictedProducts.val() !== 'undefined')?$inputRestrictedProducts.val($inputRestrictedProducts.val() + productId + '-'):$inputRestrictedProducts.val(productId + '-');
      $('#restricted_product_input').val('');
      $('#restricted_product_input').setOptions({
        extraParams: {
          ajax: true,
          action: 'getProducts',
          excludeIds : getRestrictedProduct()
        }
      });
    }
  }

  function getRestrictedProduct() {
    if ($('#inputRestrictedProducts').val() !== undefined) {
      return $('#inputRestrictedProducts').val().replace(/\-/g,',');
    }
  }

  function delRestrictedProducts(id)
  {
    var div = getE('divRestrictedProducts');
    var input = getE('inputRestrictedProducts');
    var name = getE('nameRestrictedProducts');

    // Cut hidden fields in array
    var inputCut = input.value.split('-');
    var nameCut = name.value.split('¤');

    if (inputCut.length != nameCut.length) {
      return jAlert('Bad size');
    }

    // Reset all hidden fields
    input.value = '';
    name.value = '';
    div.innerHTML = '';
    for (i in inputCut)
    {
      // If empty, error, next
      if (!inputCut[i] || !nameCut[i]) {
        continue ;
      }

      // Add to hidden fields no selected products OR add to select field selected product
      if (inputCut[i] != id) {
        input.value += inputCut[i] + '-';
        name.value += nameCut[i] + '¤';
        div.innerHTML += '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts btn btn-danger" name="' + inputCut[i] +'"><i class="icon-trash text-danger"></i></button>&nbsp;' + nameCut[i] + '</div><input type="hidden" name="product[]" value="' + inputCut[i] +'">';
      } else {
        $('#selectRestrictedProducts').append('<option selected="selected" value="' + inputCut[i] + '-' + nameCut[i] + '">' + inputCut[i] + ' - ' + nameCut[i] + '</option>');
      }
    }

    $('#restricted_product_input').setOptions({
      extraParams: {
        ajax: true,
        action: 'getProducts',
        excludeIds : getRestrictedProduct()
      }
    });
  };

  function init_types(active_type) {
    if (active_type==2) {
      $('#type_product').closest('.form-group').show();

    }else {
  $('#type_product').closest('.form-group').show();
    }
  }
  function addMore(){

  var phtml = $('#passwordTr').html();
  jQuery("#pptable > tbody:last").after(phtml);

  }
  function ppremove(el){
  jQuery(el).parent().parent().remove();


  }
  $("#addifypasswordprotected_form").submit(function(){

  pval = $("#priority").val();
  if(isNaN(pval)){
  $("#priority").focus();

  if ($("#priority").parent().find(".text-danger").length == 0) {
    $("#priority").after('<ul class="list-unstyled text-danger"><li>{l s='This value should be Numeric.' mod='addifypasswordprotected'}</li></ul>');
  }
  return false;

  }
  });

  $("#wholewebsite_on").click(function(){
  $("#type_product").parent().parent().hide();
  $("#type_category").parent().parent().parent().hide();
  $("#type_cms").parent().parent().hide();
  $("#Manufacturer").parent().parent().hide();
  $("#Supplier").parent().parent().hide();
  $('input[name="product_active"]').parent().parent().parent().hide();
  $('input[name="supplier_active"]').parent().parent().parent().hide();
  $('input[name="manufacturer_active"]').parent().parent().parent().hide();
  $('input[name="cms_active"]').parent().parent().parent().hide();
  $('input[name="category_active"]').parent().parent().parent().hide();

  });
  $("#wholewebsite_off").click(function(){
  
  $('input[name="product_active"]').parent().parent().parent().show();
  $('input[name="supplier_active"]').parent().parent().parent().show();
  $('input[name="manufacturer_active"]').parent().parent().parent().show();
  $('input[name="cms_active"]').parent().parent().parent().show();
  $('input[name="category_active"]').parent().parent().parent().show();

  if (document.getElementById("product_active_on")) {
    var ip = document.getElementById("product_active_on").checked;
    if (ip != "") {
      $("#type_product").parent().parent().show();
    }
  }

  if (document.getElementById("manufacturer_active_on")) {
    var ip = document.getElementById("manufacturer_active_on").checked;
    if (ip != "") {
      $("#Manufacturer").parent().parent().show();
    }
  }

  if (document.getElementById("cms_active_on")) {
    var ip = document.getElementById("cms_active_on").checked;
    if (ip != "") {
      $("#type_cms").parent().parent().show();
    }
  }

  if (document.getElementById("supplier_active_on")) {
    var ip = document.getElementById("supplier_active_on").checked;
    if (ip != "") {
      $("#Supplier").parent().parent().show();
    }
  }

  if (document.getElementById("category_active_on")) {
    var ip = document.getElementById("category_active_on").checked;
    if (ip != "") {
      $("#type_category").parent().parent().parent().show();
    }
  }

  });

  $("#addifypasswordprotected_enable_password_on").click(function(){
    
    $("#addifypasswordprotected_password").parent().parent().show();
  });

  $("#addifypasswordprotected_enable_password_off").click(function(){
    $("#addifypasswordprotected_password").parent().parent().hide();
  });


  $("#addifypasswordprotected_enable_customizable_message_on").click(function(){
    $(".autoload_rte").parent().parent().show();
  });

  $("#addifypasswordprotected_enable_customizable_message_off").click(function(){
    $(".autoload_rte").parent().parent().hide();
  });

  $("#addifypasswordprotected_enable_user_id_on").click(function(){
    $("#addifypasswordprotected_user_id").parent().parent().show();
  });

  $("#addifypasswordprotected_enable_user_id_off").click(function(){
    $("#addifypasswordprotected_user_id").parent().parent().hide();
  });

  $("#addifypasswordprotected_enable_user_email_on").click(function(){
    $("#addifypasswordprotecteduser_email").parent().parent().show();
  });

  $("#addifypasswordprotected_enable_user_email_off").click(function(){
    $("#addifypasswordprotecteduser_email").parent().parent().hide();
  });

  $("#addifypasswordprotected_enable_ip_address_on").click(function(){
    $("#addifypasswordprotected_ip_address").parent().parent().show();
  });

  $("#addifypasswordprotected_enable_ip_address_off").click(function(){
    $("#addifypasswordprotected_ip_address").parent().parent().hide();
  });

  if (document.getElementById("addifypasswordprotected_enable_password_on")) {
    var ip = document.getElementById("addifypasswordprotected_enable_password_on").checked;
    if (ip != "") {
      $("#addifypasswordprotected_password").parent().parent().show();
    }
  }

  if (document.getElementById("addifypasswordprotected_enable_password_off")) {
    var ip = document.getElementById("addifypasswordprotected_enable_password_off").checked;
    if (ip != "") {
      $("#addifypasswordprotected_password").parent().parent().hide();
    }
  }

  if (document.getElementById("addifypasswordprotected_enable_customizable_message_on")) {
    var ip = document.getElementById("addifypasswordprotected_enable_customizable_message_on").checked;
    if (ip != "") {
      $(".autoload_rte").parent().parent().show();
    }
  }

  if (document.getElementById("addifypasswordprotected_enable_customizable_message_off")) {
    var ip = document.getElementById("addifypasswordprotected_enable_customizable_message_off").checked;
    if (ip != "") {
      $(".autoload_rte").parent().parent().hide();
    }
  }

  if (document.getElementById("addifypasswordprotected_enable_user_id_on")) {
    var ip = document.getElementById("addifypasswordprotected_enable_user_id_on").checked;
    if (ip != "") {
      $("#addifypasswordprotected_user_id").parent().parent().show();
    }
  }

  if (document.getElementById("addifypasswordprotected_enable_user_id_off")) {
    var ip = document.getElementById("addifypasswordprotected_enable_user_id_off").checked;
    if (ip != "") {
      $("#addifypasswordprotected_user_id").parent().parent().hide();
    }
  }


  if (document.getElementById("addifypasswordprotected_enable_user_email_on")) {
    var ip = document.getElementById("addifypasswordprotected_enable_user_email_on").checked;
    if (ip != "") {
      $("#addifypasswordprotecteduser_email").parent().parent().show();
    }
  }

  if (document.getElementById("addifypasswordprotected_enable_user_email_off")) {
    var ip = document.getElementById("addifypasswordprotected_enable_user_email_off").checked;
    if (ip != "") {
      $("#addifypasswordprotecteduser_email").parent().parent().hide();
    }
  }


  if (document.getElementById("addifypasswordprotected_enable_ip_address_on")) {
    var ip = document.getElementById("addifypasswordprotected_enable_ip_address_on").checked;
    if (ip != "") {
      $("#addifypasswordprotected_ip_address").parent().parent().show();
    }
  }

  if (document.getElementById("addifypasswordprotected_enable_ip_address_off")) {
    var ip = document.getElementById("addifypasswordprotected_enable_ip_address_off").checked;
    if (ip != "") {
      $("#addifypasswordprotected_ip_address").parent().parent().hide();
    }
  }

  $("#product_active_on").click(function(){
   $("#type_product").parent().parent().show();
  });

  $("#product_active_off").click(function(){
     $("#type_product").parent().parent().hide();
  });

  $("#manufacturer_active_on").click(function(){
   $("#Manufacturer").parent().parent().show();
  });

  $("#manufacturer_active_off").click(function(){
     $("#Manufacturer").parent().parent().hide();
  });

  $("#supplier_active_on").click(function(){
   $("#Supplier").parent().parent().show();
  });

  $("#supplier_active_off").click(function(){
     $("#Supplier").parent().parent().hide();
  });

  $("#cms_active_on").click(function(){
   $("#type_cms").parent().parent().show();
  });

  $("#cms_active_off").click(function(){
     $("#type_cms").parent().parent().hide();
  });

  $("#category_active_on").click(function(){
   $("#type_category").parent().parent().parent().show();
  });

  $("#category_active_off").click(function(){
     $("#type_category").parent().parent().parent().hide();
  });

  $("#group_active_on").click(function(){
    $(".groupBox").parent().parent().parent().parent().parent().parent().parent().parent().show();
  });

  $("#group_active_off").click(function(){
    $(".groupBox").parent().parent().parent().parent().parent().parent().parent().parent().hide();
  });


  if (document.getElementById("group_active_off")) {
    var ip = document.getElementById("group_active_off").checked;
    if (ip != "") {
      $(".groupBox").parent().parent().parent().parent().parent().parent().parent().parent().hide();
    }
  }

  if (document.getElementById("product_active_off")) {
    var ip = document.getElementById("product_active_off").checked;
    if (ip != "") {
      $("#type_product").parent().parent().hide();
    }
  }

  if (document.getElementById("manufacturer_active_off")) {
    var ip = document.getElementById("manufacturer_active_off").checked;
    if (ip != "") {
      $("#Manufacturer").parent().parent().hide();
    }
  }

  if (document.getElementById("cms_active_off")) {
    var ip = document.getElementById("cms_active_off").checked;
    if (ip != "") {
      $("#type_cms").parent().parent().hide();
    }
  }

  if (document.getElementById("supplier_active_off")) {
    var ip = document.getElementById("supplier_active_off").checked;
    if (ip != "") {
      $("#Supplier").parent().parent().hide();
    }
  }

  if (document.getElementById("category_active_off")) {
    var ip = document.getElementById("category_active_off").checked;
    if (ip != "") {
      $("#type_category").parent().parent().parent().hide();
    }
  }


  {if isset($fields_value.wholewebsite) AND $fields_value.wholewebsite==1}
    $("#type_product").parent().parent().hide();
    $("#type_category").parent().parent().parent().hide();
    $("#type_cms").parent().parent().hide();
    $("#Manufacturer").parent().parent().hide();
    $("#Supplier").parent().parent().hide();
    $('input[name="product_active"]').parent().parent().parent().hide();
    $('input[name="supplier_active"]').parent().parent().parent().hide();
    $('input[name="manufacturer_active"]').parent().parent().parent().hide();
    $('input[name="cms_active"]').parent().parent().parent().hide();
    $('input[name="category_active"]').parent().parent().parent().hide();
  {/if}


   {if isset($fields_value.switch_rule_scheduling) AND $fields_value.switch_rule_scheduling==1}
    $("#Validity_from").parent().parent().parent().parent().show();
    $("#Validity_to").parent().parent().parent().parent().show();

    {else}
    $("#Validity_from").parent().parent().parent().parent().hide();
    $("#Validity_to").parent().parent().parent().parent().hide();
  {/if}


  $("#switch_rule_scheduling_on").click(function(){
    $("#Validity_from").parent().parent().parent().parent().show();
    $("#Validity_to").parent().parent().parent().parent().show();
  });

  $("#switch_rule_scheduling_off").click(function(){
    $("#Validity_from").parent().parent().parent().parent().hide();
    $("#Validity_to").parent().parent().parent().parent().hide();
  });

{/block}

