{*
* 2019 Addify
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    Addify
*  @copyright 2019 Addify
*  @license   http://opensource.org/licenses/afl-3.0.php
*}


{extends file='page.tpl'}

{block name='page_title'}
  {l s='Password Protected'  mod='addifypasswordprotected'}
{/block}
{block name='page_content'}

<style type="text/css">

  .text-sm-center{
    text-align: center;
  }

  .content-margin {
    margin-bottom: 0.563rem;
  }
 /* #submit-login{
    display: none;
  }*/

  @media only screen and (max-width: 600px) {
    .content-center{
      text-align: center;
    }
  }

</style>

    {if isset($complete_tries) && $complete_tries}
      <input type="hidden" id="unsuccessfultry" name="unsuccessfultry" value= "1">
      <ul class="ps-alert-error">
        <li class="item">
          <i>
            <svg viewBox="0 0 24 24">
              <path fill="#fff" d="M11,15H13V17H11V15M11,7H13V13H11V7M12,2C6.47,2 2,6.5 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M12,20A8,8 0 0,1 4,12A8,8 0 0,1 12,4A8,8 0 0,1 20,12A8,8 0 0,1 12,20Z"></path>
            </svg>
          </i>
          <p>{l s='Password is not correct and your password limit exceeds so try later'  mod='addifypasswordprotected'} </p>
        </li>
      </ul>
    {elseif isset($confirmation) && $confirmation}
      <ul class="ps-alert-error">
        <li class="item">
          <i>
            <svg viewBox="0 0 24 24">
              <path fill="#fff" d="M11,15H13V17H11V15M11,7H13V13H11V7M12,2C6.47,2 2,6.5 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M12,20A8,8 0 0,1 4,12A8,8 0 0,1 12,4A8,8 0 0,1 20,12A8,8 0 0,1 12,20Z"></path>
            </svg>
          </i>
          <p>{l s='Password is not correct'  mod='addifypasswordprotected'} </p>
        </li>
      </ul>
    {/if}
    <header>
      <p class="send-renew-password-link"> {l s='Content you are trying to access is password protected.'  mod='addifypasswordprotected'}</p>
    </header>
    <form action="" method="post" class="std" id="form_passwordprotected">

      <section class="form-fields">
        <div class="form-group row">
          <label class="col-md-3 form-control-label required">{l s='Password'  mod='addifypasswordprotected'}</label>
          <div class="col-md-6">
            <div class="input-group content-margin">
              <input class="form-control" type="password" id="password" required name="pp_password">
            </div>
          </div>
            <input type="hidden" name="passwordProtectedKey" value="{$passwordProtectedKey|escape:'htmlall':'UTF-8'}" >
            <div class="content-center">
              <button class="form-control-submit btn btn-primary" id="submit-login" name="submit" type="submit" {if isset($complete_tries) && $complete_tries} disabled {/if}>
                {l s='Unlock'  mod='addifypasswordprotected'}
              </button>
            </div>
        </div>
      </section>
    </form>

    {if $contact_us == 1}
      <div class="text-sm-center">
        <a href="{$contact_url|escape:'htmlall':'UTF-8'}" class="btn btn-primary">{l s='Contact us'  mod='addifypasswordprotected'}</a>
      </div>
    {/if}

    {if $enable_customizable_message == 1}
      {if $disable_customize_msg == 1}
        {$customizable_message nofilter}
      {/if}
    {/if} 
{/block}